// Fichero de implementacin de funciones para tratamiento de cadenas
#include <string.h>
#include <math.h>
#include "cadena.h"

CADENA crear_cadena1() {
    CADENA res;
    int i;

    res.posicion=0;
    res.longitud=0;
    for (i=0;i<MAXCAR;i++)
        res.contenido[i]=0;

    return(res);
}

CADENA crear_cadena2(char *cad) {
    int longitud,i;
    CADENA res;

    longitud=strlen(cad);

    res=crear_cadena1();

    for (i=0;i<longitud && i<MAXCAR-1;i++)
        res.contenido[i]=cad[i];

    res.longitud=longitud;

    return(res);
}

CADENA copiar_cadena(CADENA cad) {
    CADENA res;
    int i;

    res=crear_cadena1();

    for (i=0;i<MAXCAR;i++)
        res.contenido[i]=cad.contenido[i];

    res.longitud=cad.longitud;
    res.posicion=0;

    return(res);
}

LOGICO comparar_cadenas(CADENA cad1,CADENA cad2) {
    LOGICO res=FALSO,fin=FALSO;
    int i;

    if (cad1.longitud==cad2.longitud) {
        for (i=0;i<cad1.longitud && !fin;i++)
            if (cad1.contenido[i]=!cad2.contenido[i])
                fin=CIERTO;
        if (!fin)
            res=CIERTO;
    }

    return(res);
}

CADENA anadir_caracter_cadena(CADENA cad,char car) {
    CADENA res;

    if (cad.longitud<MAXCAR-2) {
        res=copiar_cadena(cad);
        res.contenido[cad.longitud]=car;
        res.contenido[cad.longitud+1]='\0';
        res.longitud++;
    }

    return(res);
}

CADENA concatenar_cadenas1(CADENA cad1,CADENA cad2) {
    CADENA res;
    int i;

    res=crear_cadena1();
    res=copiar_cadena(cad1);

    for (i=0;i<cad2.longitud && i<MAXCAR-1;i++)
        res.contenido[cad1.longitud+i]=cad2.contenido[i];

    res.posicion=0;
    res.longitud=cad1.longitud+cad2.longitud;

    return(res);
}

CADENA concatenar_cadenas2(char *cad1,char *cad2) {
    CADENA rc1,rc2;
    int i;

    rc1=crear_cadena2(cad1);
    rc2=crear_cadena2(cad2);

    return(concatenar_cadenas1(rc1,rc2));
}

CADENA eliminar_caracter_cadena(CADENA cad) {
    if (cad.longitud>0) {
        cad.contenido[cad.longitud--]=0;
        if (cad.posicion<cad.longitud)
            cad.posicion--;
    }

    return(cad);
}

CADENA num2cad(int numero) {
    short longitud,i;
    CADENA res;

    res=crear_cadena1();

    if (numero>0) {
        longitud=floor(log10(numero))+1;
        for (i=0;i<longitud;i++) {
            res.contenido[longitud-(i+1)]='0'+numero%10;
            numero/=10;
        }
        res.longitud=longitud;
    } else if (numero==0)
        res.contenido[0]='0';
    else
        res=crear_cadena2("N/A");

    return(res);
}

void rtrim(char *cadena) {
    int l=strlen(cadena);
    int i;

    for (i=0;i<l;i++) {
        if (cadena[i] == ' ') {
            cadena[i]=0;
            break;
        }
    }
}

void minusculas(char *cadena) {
    int l=strlen(cadena);
    int i;

    for (i=0;i<l;i++)
        if (cadena[i]>=65 && cadena[i]<=90)
            cadena[i]+=32;
}
