//#define ALLEGRO_STATICLINK

/*
	dt's empleados ya:
	
	dt = 1
	dt = 2
	dt = 3
	dt = 4
	dt = 5
	dt = 9
	dt = 22
	dt = 30
	dt = 41
	dt = 70			SNOW + Halo
	dt = 80
	dt = 98
	dt = 99
		
*/

#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <allegro.h>
#include <fmod.h>
#include "fblend.h"
#include "mapfile.h"
#include "cadena.h"
#include "motor.h"
#include "juego.h"
#include "temporizadores.h"
#include "texto.h"
#include "menu.h"

#define MAX_LLUVIA 500
#define MAX_NIEVE 100
#define MAX_LUCIERNAGA 5

typedef struct {
    int x,y,l;
} TIPO_LLUVIA;

typedef struct {
    int x, y, mx, my;
    int count, ax, ay;
    int nextcount;
} TIPO_LUCIERNAGA;

int dt;
int ct_scroll=0;
int ct_ta=0;
int angle=0;
int incA[32]={-1295,-1167,-1041,-919,-798,-683,-573,-473,-378,-291,-217,-151,-97,-53,-23,-5,5,23,53,97,151,217,291,378,473,573,683,798,919,1041,1164,1295};
int incL[32]={-662,-596,-529,-465,-403,-342,-286,-232,-186,-142,-102,-68,-42,-19,-7,-0,0,7,19,42,68,102,142,186,232,286,342,403,465,529,596,622};
int tbls[10];
int tblc[10];
int ctbls;
int n_efec;
int sin_tbl[144];
int idx1 = 0;
int idx2 = 0;
LOGICO has_efec=FALSO;
SIMPLE mvl[MAX_MVL];
SIMPLE mvl2[MAX_MVL];
TIPO_LLUVIA lluvia[MAX_LLUVIA];
TIPO_LUCIERNAGA luciernagas[MAX_LUCIERNAGA];
int fuerza_viento=0;
int soplador_value=0;
int soplador_contador=0;
int soplador_incremento=0;
int trueno_activo=0;
int l_trueno = 5;
BITMAP *background_restorer;
BITMAP *pizarra;
BITMAP *dark_overlay;
BITMAP *fancy_overlay;
BITMAP *fancy_overlay_2;
BITMAP *war_overlay;
BITMAP *halo;
BITMAP *halo_rojo;
BITMAP *halo_amarillo;
BITMAP *anti_halo;
BITMAP *vaho;
BITMAP *polvo;
BITMAP *buffer_auxiliar;
BITMAP *buffer_auxiliar_2;
BITMAP *numeros;
BITMAP *snow [3];
BITMAP *snow_pcx;
short n_mvl=0;
short explosion, explosion_life;
char mvl2idx;
char mvl2ct = 0;
FSOUND_SAMPLE *samples_ciudad[3];
FSOUND_SAMPLE *s_bomb;
int sample_lluvia_activo=1;
char buffer_pos_lineas[144];
char contador_efecto = 0;
unsigned int transparente;
int lost_focus;

short signo(int a) {
    if (a<0)
        return -1;
    else if (a>0)
        return 1;
    else
        return 0;
}

LOGICO recorta_tiles(char *nombre, BITMAP *tiles[]) {
    int i,x,y;
    BITMAP *pcx;
    LOGICO res=FALSO;
    PALETTE pal;

    pcx=create_bitmap(384,160);
    pcx=load_pcx(nombre,pal);

    if (pcx!=NULL) {
        res=CIERTO;
        x=0;
        y=0;
        for (i=0;i<240;i++) {
            blit(pcx,tiles[i],x,y,0,0,16,16);
            x+=16;
            if (x==384) {
                x=0;
                y+=16;
            }
        }
    }

    return res;
}

LOGICO carga_fase(char *nombre,\
                  CABECERA *cabecera, MAPA mapa, OBJ *palancas, OBJ *energias,\
                  BITMAP *fondos[], BITMAP *tiles[], BITMAP *sprites[]) {
    int l;
    LOGICO exito=CIERTO;
    unsigned char flags;
    int n_efec_mapa;
    CADENA nombrePCXs[7];
    CADENA cad;
    PALANCAS p;
    ENERGIAS e;


    l=strlen(nombre);


    cad=concatenar_cadenas2("map\\",nombre);
    exito = cargarMapa(cad.contenido, &flags, nombrePCXs, cabecera, mapa, p, e, fondos, tiles, sprites, &n_efec_mapa);
    if (exito && esJugable(flags)) {
        if (tieneEfecto(flags)) {
            n_efec = n_efec_mapa;
            has_efec = CIERTO;
        } else {
            has_efec = FALSO;
        }
    }

    if (exito) {
        for (l=0;l<25;l++) {
            palancas[l].n=p[l].yp*5+p[l].xp;
            energias[l].n=e[l].yp*5+e[l].xp;
            palancas[l].x=p[l].x;
            palancas[l].y=p[l].y;
            energias[l].x=e[l].x;
            energias[l].y=e[l].y;
            palancas[l].on=CIERTO;
            energias[l].on=CIERTO;
        }
    }

    return exito;
}

void traza_sombras (JUGADOR phantomas,ENEMIGO *enemigos,ENEMIGO *plataformas,MAPA mapa,OBJ *palancas,OBJ *energias,unsigned char n,\
                    BITMAP *tiles[],BITMAP *sprites[],BITMAP *fondos[],BITMAP *pantalla,CABECERA cabecera) {
    // Pseudorender simple y escalado traslucido ! ! ! q mieo.
    int i, j;

    clear_to_color (buffer_auxiliar, transparente);

    // Tiles1:
    for (i=0;i<9;i++)
        for (j=0;j<15;j++) {
            if (mapa[n].tiles[i][j].tile1 != -1)
                masked_blit(tiles[mapa[n].tiles[i][j].tile1],buffer_auxiliar,0,0,j<<4,i<<4,16,16);
        }

    // Sprites:

    for (i=0;i<25;i++) {
        if (palancas[i].n == n) {
            if (palancas[i].on)
                masked_blit(sprites[192],buffer_auxiliar,0,0,palancas[i].x<<4,palancas[i].y<<4,16,16);
            else
                masked_blit(sprites[216],buffer_auxiliar,0,0,palancas[i].x<<4,palancas[i].y<<4,16,16);
        }
        if (energias[i].n == n) {
            if (energias[i].on)
                masked_blit(sprites[193],buffer_auxiliar,0,0,energias[i].x<<4,energias[i].y<<4,16,16);
            else
                masked_blit(sprites[217],buffer_auxiliar,0,0,energias[i].x<<4,energias[i].y<<4,16,16);
        }
    }

    for (i=0;i<NENEM;i++) {
        if (enemigos[i].id != -1) {
            if (enemigos[i].mx >= 0)
                draw_sprite(buffer_auxiliar,sprites[enemigos[i].id+enemigos[i].frame],enemigos[i].x,enemigos[i].y);
            else
                draw_sprite_h_flip(buffer_auxiliar,sprites[enemigos[i].id+enemigos[i].frame],enemigos[i].x,enemigos[i].y);
        }
    }

    for (i=0;i<NPLAT;i++) {
        if (plataformas[i].id != -1) {
            draw_sprite(buffer_auxiliar,sprites[plataformas[i].id+plataformas[i].frame],plataformas[i].x,plataformas[i].y);
        }
    }

    if (phantomas.cayendo) {
        draw_sprite(buffer_auxiliar,sprites[phantomas.mira_izda+96+phantomas.frame],phantomas.x>>8,phantomas.y>>8);
    } else {
        if (phantomas.saltando) {
            draw_sprite(buffer_auxiliar,sprites[phantomas.mira_izda+72],phantomas.x>>8,phantomas.y>>8);
        } else {
            if (phantomas.frame==0 || phantomas.frame == 48) {
                draw_sprite(buffer_auxiliar,sprites[phantomas.mira_izda],phantomas.x>>8,phantomas.y>>8);
            } else if (phantomas.frame==24) {
                draw_sprite(buffer_auxiliar,sprites[phantomas.mira_izda+24],phantomas.x>>8,phantomas.y>>8);
            } else {
                draw_sprite(buffer_auxiliar,sprites[phantomas.mira_izda+48],phantomas.x>>8,phantomas.y>>8);
            }
        }
    }

    for (i=0;i<9;i++)
        for (j=0;j<15;j++) {
            if (mapa[n].tiles[i][j].tile2 != -1)
                masked_blit(tiles[mapa[n].tiles[i][j].tile2],buffer_auxiliar,0,0,j<<4,i<<4,16,16);

        }

    // Ampliar:
    stretch_blit (buffer_auxiliar, buffer_auxiliar_2, (phantomas.x>>8)/7,(phantomas.y>>8)/4,208,112,  0,0,240,144);

    // Volcar:
    clear_to_color (buffer_auxiliar, transparente);
    draw_lit_sprite (buffer_auxiliar, buffer_auxiliar_2, 0, 0, 255);

    // Traslucido:
    if (dt != 5)
        fblend_trans (buffer_auxiliar, pantalla, 0, 0, 128);
    else
        fblend_trans (buffer_auxiliar, pantalla, 0, 0, 64);
}

int render(JUGADOR phantomas,ENEMIGO *enemigos,ENEMIGO *plataformas,MAPA mapa,OBJ *palancas,OBJ *energias,unsigned char n,\
           BITMAP *tiles[],BITMAP *sprites[],BITMAP *fondos[],BITMAP *pantalla,CABECERA cabecera) {
    int i,j;
    short xp,yp,xmr;
    int res;

    // Primer volcado: El fondo
    yp=n/5;
    xp=n%5;

    if (dt==22 && rand()%100 == 7 && yp<4 && !(yp == 0 && xp > 2)) {
        trueno_activo = 1;
        l_trueno = 2+rand()%5;
        if (config.audio)
            FSOUND_PlaySound (FSOUND_FREE, samples_ciudad[2]);
    } else if (dt==99) {
        if (mapa[n].idfondo != -1)
            draw_trans_sprite(pantalla,fondos[mapa[n].idfondo],0,0);
        else {
            drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
            rectfill(pantalla,0,0,239,143,0);
            drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
        }
        stretch_blit(pantalla,pizarra,0,0,240,144,0,0,232,138);
        draw_sprite(pantalla,pizarra,4+sin_tbl[idx1],3+(sin_tbl[idx2]>>1));
        idx1++;
        idx2+=2;
        if (idx1==72)
            idx1=0;
        if (idx2==72)
            idx2=0;
    } else if (dt==98) {
        if (mapa[n].idfondo != -1)
            draw_trans_sprite(pantalla,fondos[mapa[n].idfondo],0,0);
        else {
            drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
            rectfill(pantalla,0,0,239,143,0);
            drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
        }
        stretch_blit(pantalla,pizarra,0,0,240,144,0,0,232,138);
        draw_sprite(pantalla,pizarra,4,3);
    } else if ((dt==5 && xp==4) || (dt==4 && yp==3 && xp>=2)) {
        for (i=0;i<144;i++) {
            res=angle+i;
            if (res>=144) res-=144;

            if (sin_tbl[res]>=0)
                hline(pantalla,0,i,sin_tbl[res],getpixel(fondos[mapa[n].idfondo],0,i));
            else
                hline(pantalla,240+sin_tbl[res],i,239,getpixel(fondos[mapa[n].idfondo],239,i));

            blit(fondos[mapa[n].idfondo],pantalla,0,i,sin_tbl[res],i,240,1);
        }
        angle++;
        if (angle==144) angle=0;
    } else if (dt==9) {
        if (mapa[n].idfondo != -1) {
            blit(fondos[mapa[n].idfondo],pantalla,0,0,ct_scroll,0,240-ct_scroll,144);
            blit(fondos[mapa[n].idfondo],pantalla,240-ct_scroll,0,0,0,ct_scroll,144);
            ct_scroll++;
            if (ct_scroll==240)
                ct_scroll=0;
        }
    } else if (dt == 30) {	// EKYNOX - Aadido por na_th_an el 13 de Junio de 2005
        if ( (yp < 4 && xp > 2) || (yp == 0 && xp == 2) ) {
            for (i = 0; i < 144; i ++) {
                if (contador_efecto == 0) {
                    res = (rand () % 3) - 1;
                    buffer_pos_lineas[i] = res;
                } else
                    res = buffer_pos_lineas[i];

                if (res == 1)
                    putpixel (pantalla, 0, i, getpixel (fondos[mapa[n].idfondo], 0, i));
                else if (res == -1)
                    putpixel (pantalla, 239, i, getpixel (fondos[mapa[n].idfondo], 239, i));

                blit (fondos[mapa[n].idfondo], pantalla, 0, i, res, i, 240, 1);
            }
            contador_efecto = (contador_efecto + 1) & 3;
        } else {
            if (mapa[n].idfondo != -1)
                blit(fondos[mapa[n].idfondo],pantalla,0,0,0,0,240,144);
            else
                rectfill(pantalla,0,0,239,143,0);
        }
    } else {
        if (mapa[n].idfondo != -1)
            blit(fondos[mapa[n].idfondo],pantalla,0,0,0,0,240,144);
        else
            rectfill(pantalla,0,0,239,143,0);
    }

    // Test: volcado 1.5: Sombras !! Aadido por na_th_an 2006-01-27
    if (dt == 80) {	// CLASSIC.PH3
        if (yp > 0 && xp < 4 && !(xp == 3 && yp == 1))
            traza_sombras (phantomas, enemigos, plataformas, mapa, palancas, energias, n, tiles, sprites, fondos, pantalla, cabecera);
    } else if (dt == 1) {	// CUEVA.PH3
        if (yp != 4 || xp != 4)
            traza_sombras (phantomas, enemigos, plataformas, mapa, palancas, energias, n, tiles, sprites, fondos, pantalla, cabecera);
    } else if (dt == 5) {	// JILL.PH3
        if (yp > 0 && xp < 2)
            traza_sombras (phantomas, enemigos, plataformas, mapa, palancas, energias, n, tiles, sprites, fondos, pantalla, cabecera);
    } else if (dt == 30) {	// EKYNOX.PH3
        if (yp == 4)
            traza_sombras (phantomas, enemigos, plataformas, mapa, palancas, energias, n, tiles, sprites, fondos, pantalla, cabecera);
    }

    // WAR:: obuses de fondo :D
    if (dt == 41) {
        mvl2 [0].x += mvl2 [0].mx;
        mvl2 [0].y += mvl2 [0].my;
        if (mvl2 [0].y > 36864) {
            mvl2 [0].x = (rand() % 240) << 8;
            mvl2 [0].y = -8192 - ((rand() & 31) << 12) ;
            mvl2 [0].mx = ((rand()%512) - 256) << 1;
            mvl2 [0].my = 1024;
            explosion = 1;
            explosion_life = 30;
            FSOUND_PlaySound (FSOUND_FREE, s_bomb);
        }

        mvl2ct = (mvl2ct + 1) & 2;

        if (mvl2 [0].y > -8192 && mvl2ct == 0) {
            mvl2 [mvl2idx].x = mvl2 [0].x;
            mvl2 [mvl2idx].y = mvl2 [0].y;
            mvl2 [mvl2idx].frame = 32;

            mvl2idx ++;
            if (mvl2idx == MAX_MVL) mvl2idx = 1;
        }

        for (i = 1; i < MAX_MVL; i ++)
            if (mvl2 [i].frame != 0) {
                fblend_add (sprites [22], pantalla, mvl2 [i].x >> 8, mvl2 [i].y >> 8, mvl2 [i].frame << 3);

                mvl2 [i].frame --;
            }

        fblend_trans (sprites [23], pantalla, mvl2 [0].x >> 8, mvl2 [0].y >> 8, 128);
        fblend_add (halo, pantalla, (mvl2 [0].x >> 8) - 16, (mvl2 [0].y >> 8) - 16, 128);
    }


    // Segundo volcado: Capa de Tiles 1

    if (dt==2 || dt==4 || dt>97 || dt==9 || dt==22) {
        for (i=0;i<9;i++)
            for (j=0;j<15;j++) {
                if (mapa[n].tiles[i][j].tile1 != -1)
                    if (mapa[n].tiles[i][j].tile1<216)
                        masked_blit(tiles[mapa[n].tiles[i][j].tile1],pantalla,0,0,j<<4,i<<4,16,16);
                    else {
                        draw_trans_sprite(pantalla,tiles[mapa[n].tiles[i][j].tile1],j<<4,i<<4);
                        masked_blit(tiles[mapa[n].tiles[i][j].tile1+6],pantalla,0,0,j<<4,i<<4,16,16);
                    }
            }
    } else if (dt == 5) {
        for (i=0;i<9;i++)
            for (j=0;j<15;j++) {
                if (mapa[n].tiles[i][j].tile1 == 183 || mapa[n].tiles[i][j].tile1 == 187)
                    fblend_trans (tiles [213], pantalla, j<<4,i<<4, 128);
                else if (mapa[n].tiles[i][j].tile1 == 196 || mapa[n].tiles[i][j].tile1 == 197)
                    fblend_trans (tiles [214], pantalla, j<<4,i<<4, 128);
                else if (mapa[n].tiles[i][j].tile1 == 135 || mapa[n].tiles[i][j].tile1 == 139)
                    fblend_trans (tiles [215], pantalla, j<<4,i<<4, 128);

                if (mapa[n].tiles[i][j].tile1 != -1)
                    masked_blit(tiles[mapa[n].tiles[i][j].tile1],pantalla,0,0,j<<4,i<<4,16,16);
            }
    } else {
        for (i=0;i<9;i++)
            for (j=0;j<15;j++) {
                if (mapa[n].tiles[i][j].tile1 != -1)
                    masked_blit(tiles[mapa[n].tiles[i][j].tile1],pantalla,0,0,j<<4,i<<4,16,16);
            }
    }

    // Volcado 2 y medio: la puerta!

    if (xp==cabecera.pfi_x && yp==cabecera.pfi_y)
        if (phantomas.n_palancas==25) {
            masked_blit(sprites[50],pantalla,0,0,cabecera.fin_x<<4,cabecera.fin_y<<4,16,16);
            masked_blit(sprites[74],pantalla,0,0,cabecera.fin_x<<4,cabecera.fin_y+1<<4,16,16);
        } else {
            masked_blit(sprites[2],pantalla,0,0,cabecera.fin_x<<4,cabecera.fin_y<<4,16,16);
            masked_blit(sprites[26],pantalla,0,0,cabecera.fin_x<<4,cabecera.fin_y+1<<4,16,16);
        }

    // Tercer volcado: Palancas y Energas

    if (dt == 6) {
        for (i=0;i<25;i++) {
            if (palancas[i].n == n) {
                if (palancas[i].on)
                    masked_blit(sprites[192],pantalla,0,0,palancas[i].x<<4,palancas[i].y<<4,16,16);
                else
                    masked_blit(sprites[216],pantalla,0,0,palancas[i].x<<4,palancas[i].y<<4,16,16);
            }
            if (energias[i].n == n) {
                if (energias[i].on) {
                    fblend_add (halo, pantalla, (energias[i].x<<4) - 16 + (rand() % 3 - 1), (energias[i].y<<4) - 16 + (rand() % 3 - 1), 128);
                    masked_blit(sprites[193],pantalla,0,0,energias[i].x<<4,energias[i].y<<4,16,16);
                } else
                    masked_blit(sprites[217],pantalla,0,0,energias[i].x<<4,energias[i].y<<4,16,16);
            }
        }
    } else {
        for (i=0;i<25;i++) {
            if (palancas[i].n == n) {
                if (palancas[i].on)
                    masked_blit(sprites[192],pantalla,0,0,palancas[i].x<<4,palancas[i].y<<4,16,16);
                else
                    masked_blit(sprites[216],pantalla,0,0,palancas[i].x<<4,palancas[i].y<<4,16,16);
            }
            if (energias[i].n == n) {
                if (energias[i].on)
                    masked_blit(sprites[193],pantalla,0,0,energias[i].x<<4,energias[i].y<<4,16,16);
                else
                    masked_blit(sprites[217],pantalla,0,0,energias[i].x<<4,energias[i].y<<4,16,16);
            }
        }
    }

    // Cuarto volcado: Sprites!!

    // 1 enemigos y plataformas:

    for (i=0;i<NENEM;i++) {
        if (dt == 80) {	// Enemigos traslcidos
            if (enemigos[i].id != -1) {
                if (enemigos[i].id != 11 && enemigos[i].id != 110) {
                    if (enemigos[i].mx >= 0)
                        draw_sprite(pantalla,sprites[enemigos[i].id+enemigos[i].frame],enemigos[i].x,enemigos[i].y);
                    else
                        draw_sprite_h_flip(pantalla,sprites[enemigos[i].id+enemigos[i].frame],enemigos[i].x,enemigos[i].y);
                } else {
                    fblend_add (sprites[enemigos[i].id+enemigos[i].frame], pantalla, enemigos[i].x,enemigos[i].y, 64);
                }
            }
        } else if (dt == 30) {	// Ekynox
            if (enemigos[i].id != -1) {
                if (enemigos[i].id != 6 && enemigos[i].id != 102 && enemigos[i].id != 103 && !(enemigos[i].id >= 13 && enemigos[i].id <= 18)) {
                    if (enemigos[i].mx >= 0)
                        draw_sprite(pantalla,sprites[enemigos[i].id+enemigos[i].frame],enemigos[i].x,enemigos[i].y);
                    else
                        draw_sprite_h_flip(pantalla,sprites[enemigos[i].id+enemigos[i].frame],enemigos[i].x,enemigos[i].y);
                } else if (enemigos[i].id >= 13 && enemigos[i].id <= 18) {
                    draw_sprite(pantalla,sprites[enemigos[i].id+enemigos[i].frame],enemigos[i].x,enemigos[i].y);
                    fblend_add (sprites[96 + enemigos[i].id+enemigos[i].frame], pantalla, enemigos[i].x,enemigos[i].y, 96);
                } else {
                    fblend_add (sprites[enemigos[i].id+enemigos[i].frame], pantalla, enemigos[i].x,enemigos[i].y, 128 - enemigos[i].frame/2);
                }
            }
        } else {
            if (enemigos[i].id != -1) {
                if (enemigos[i].mx >= 0)
                    draw_sprite(pantalla,sprites[enemigos[i].id+enemigos[i].frame],enemigos[i].x,enemigos[i].y);
                else
                    draw_sprite_h_flip(pantalla,sprites[enemigos[i].id+enemigos[i].frame],enemigos[i].x,enemigos[i].y);
            }
        }
    }

    if (dt!=6) {
        for (i=0;i<NPLAT;i++) {
            if (plataformas[i].id != -1) {
                draw_sprite(pantalla,sprites[plataformas[i].id+plataformas[i].frame],plataformas[i].x,plataformas[i].y);
            }
        }
    }

    // Detalles:
    if (dt==1 || dt==3) {	// Iluminacin tras phantomas
        /*
        	i=rand()%4;
        	draw_trans_sprite(pantalla,sprites[98+i],(phantomas.x>>8)-8,(phantomas.y>>8)-8);
        	draw_trans_sprite(pantalla,sprites[122+i],(phantomas.x>>8)-8,(phantomas.y>>8)+8);
        	draw_trans_sprite(pantalla,sprites[146+i],(phantomas.x>>8)+8,(phantomas.y>>8)-8);
        	draw_trans_sprite(pantalla,sprites[170+i],(phantomas.x>>8)+8,(phantomas.y>>8)+8);
        */
        fblend_add (halo, pantalla, (phantomas.x >> 8) - 16, (phantomas.y >> 8) - 16, 128);
    } else if (dt == 80) {
        if (yp > 0 && xp < 4 && !(yp == 1 && xp == 3))
            fblend_add (halo, pantalla, (phantomas.x >> 8) - 16, (phantomas.y >> 8) - 16, 128);
    } else if (dt==4) {				// Fuegos fatuos
        fblend_add (halo, pantalla, (phantomas.x >> 8) - 16, (phantomas.y >> 8) - 16, 64);

        for (i=0;i<9;i++) {
            mvl[i].x=mvl[i+1].x;
            mvl[i+10].x=mvl[i+11].x;
            mvl[i].y=mvl[i+1].y;
            mvl[i+10].y=mvl[i+11].y;
            mvl[i].ctbls=mvl[i+1].ctbls;
            mvl[i+10].ctbls=mvl[i+11].ctbls;
        }
        mvl[i].x=(phantomas.x>>8)-12;
        mvl[i+10].x=(phantomas.x>>8)+12;
        mvl[i].y=(phantomas.y>>8)-8;
        mvl[i+10].y=(phantomas.y>>8)-8;
        mvl[i].ctbls=ctbls;
        mvl[i+10].ctbls=ctbls;

        for (i=0;i<5;i++) {
            fblend_add (sprites[98+mvl[0].frame], pantalla, mvl[i].x+tbls[mvl[i].ctbls], mvl[i<<1].y+tblc[mvl[i].ctbls], 64);
            fblend_add (sprites[98+mvl[0].frame], pantalla, mvl[(i<<1)+10].x+tbls[mvl[i].ctbls], mvl[(i<<1)+10].y+tblc[mvl[i].ctbls], 64);
        }

        mvl[0].frame+=24;
        if (mvl[0].frame>=96) mvl[0].frame=0;
        ctbls++;
        if (ctbls==10) ctbls=0;
    }

    // Lucirnagas

    if (dt == 2 && xp < 4) {
        for (i = 0; i < MAX_LUCIERNAGA; i ++) {
            luciernagas[i].x += luciernagas[i].mx;
            luciernagas[i].y += luciernagas[i].my;

            if (luciernagas[i].x <= 0 || luciernagas[i].x >= 61440)		// 61440 = 240 << 8
                luciernagas[i].mx = -luciernagas[i].mx;

            if (luciernagas[i].y <= 0 || luciernagas[i].y >= 36864)		// 36864 = 144 << 8
                luciernagas[i].my = -luciernagas[i].my;

            luciernagas[i].mx += luciernagas[i].ax;
            luciernagas[i].my += luciernagas[i].ax;
            luciernagas[i].count ++;
            if (luciernagas[i].count == luciernagas[i].nextcount) {
                luciernagas[i].mx = ((rand() % 5) - 2) * 32;
                luciernagas[i].my = ((rand() % 5) - 2) * 32;
                luciernagas[i].ax = rand() % 8 - 4;
                luciernagas[i].ay = rand() % 8 - 4;
                luciernagas[i].count = 0;
                luciernagas[i].nextcount = 20 + (rand() % 40);
            }

            fblend_add (tiles[23], pantalla, (luciernagas[i].x >> 8) - 8, (luciernagas[i].y >> 8) - 8, 88 + rand() % 16);
            putpixel (pantalla, (luciernagas[i].x >> 8), (luciernagas[i].y >> 8), makecol (255,255,230));
        }
    }

    // 2 phantomas:
		
	if (phantomas.etoy_muelto) {
		fblend_add (sprites[phantomas.mira_izda+72], pantalla, phantomas.x>>8, phantomas.y>>8, 120 + rand() % 16);
	} else {
	    if (phantomas.cayendo) {
	        draw_sprite(pantalla,sprites[phantomas.mira_izda+96+phantomas.frame],phantomas.x>>8,phantomas.y>>8);
	    } else {
	        if (phantomas.saltando) {
	            draw_sprite(pantalla,sprites[phantomas.mira_izda+72],phantomas.x>>8,phantomas.y>>8);
	        } else {
	            if (phantomas.frame==0 || phantomas.frame == 48) {
	                draw_sprite(pantalla,sprites[phantomas.mira_izda],phantomas.x>>8,phantomas.y>>8);
	            } else if (phantomas.frame==24) {
	                draw_sprite(pantalla,sprites[phantomas.mira_izda+24],phantomas.x>>8,phantomas.y>>8);
	            } else {
	                draw_sprite(pantalla,sprites[phantomas.mira_izda+48],phantomas.x>>8,phantomas.y>>8);
	            }
	        }
	    }
	}

    // Quinto volcado: Capa de Tiles 2

    if (dt>1)
        xmr=216;
    else
        xmr=232;

    if (dt==1 || dt==2 || dt==4 || dt>97 || dt==9 || dt==22) {
        for (i=0;i<9;i++)
            for (j=0;j<15;j++) {
                if (dt==9) {
                    if (mapa[n].tiles[i][j].tile2==96 ||	mapa[n].tiles[i][j].tile2==120 || mapa[n].tiles[i][j].tile2==144 ||  mapa[n].tiles[i][j].tile2==168) {
                        ct_ta++;
                        if (ct_ta==4) {
                            ct_ta=0;
                            mapa[n].tiles[i][j].tile2+=24;
                            if (mapa[n].tiles[i][j].tile2>168)
                                mapa[n].tiles[i][j].tile2=96;
                        }
                    }
                }
                if (mapa[n].tiles[i][j].tile2 != -1) {
                    if (mapa[n].tiles[i][j].tile2<xmr) {
                        masked_blit(tiles[mapa[n].tiles[i][j].tile2],pantalla,0,0,j<<4,i<<4,16,16);
                    } else {
                        if (dt == 2 || dt == 22) {
                            if (mapa[n].tiles[i][j].tile2 > 222)
                                fblend_add (tiles[mapa[n].tiles[i][j].tile2], pantalla, j<<4, i<<4, 64);
                            else
                                fblend_trans (tiles[mapa[n].tiles[i][j].tile2], pantalla, j<<4, i<<4, 172);
                        } else {
                            fblend_trans (tiles[mapa[n].tiles[i][j].tile2], pantalla, j<<4, i<<4, 64);
                        }
                    }
                }
            }


        if (dt == 22)
            for (i=0;i<9;i++)
                for (j=0;j<15;j++)
                    if (mapa[n].tiles[i][j].tile2 == 120 || mapa[n].tiles[i][j].tile1 == 120)
                        fblend_add (halo, pantalla, (j<<4) - 16, (i<<4) - 16, 128);
    } else if (dt==6) {
        for (i=0;i<9;i++)
            for (j=0;j<15;j++) {
                if (mapa[n].tiles[i][j].tile2 != -1) {
                    if (mapa[n].tiles[i][j].tile2<235)
                        masked_blit(tiles[mapa[n].tiles[i][j].tile2],pantalla,0,0,j<<4,i<<4,16,16);
                    else {
                        fblend_trans (tiles[mapa[n].tiles[i][j].tile2], pantalla, j<<4, i<<4, 128);

                        switch (mapa[n].tiles[i][j].tile2) {
                        case 237:
                            masked_blit(tiles[48],pantalla,0,0,j<<4,i<<4,16,16);
                            break;
                        case 235:
                            masked_blit(tiles[49],pantalla,0,0,j<<4,i<<4,16,16);
                            break;
                        case 236:
                            masked_blit(tiles[50],pantalla,0,0,j<<4,i<<4,16,16);
                            break;
                        case 239:
                            masked_blit(tiles[51],pantalla,0,0,j<<4,i<<4,16,16);
                            break;
                        }
                    }
                }
            }

        for (i=0;i<9;i++)
            for (j=0;j<15;j++)
                if (mapa[n].tiles[i][j].tile2 == 75 || mapa[n].tiles[i][j].tile2 == 120 || mapa[n].tiles[i][j].tile2 == 209 || mapa[n].tiles[i][j].tile1 == 75 || mapa[n].tiles[i][j].tile1 == 120 || mapa[n].tiles[i][j].tile1 == 209)
                    fblend_add (halo, pantalla, (j<<4) - 16, (i<<4) - 16, 128);
    } else if (dt == 5) {
        for (i=0;i<9;i++)
            for (j=0;j<15;j++) {
                if (mapa[n].tiles[i][j].tile2 == 183 || mapa[n].tiles[i][j].tile2 == 187)
                    fblend_trans (tiles [213], pantalla, j<<4,i<<4, 128);
                else if (mapa[n].tiles[i][j].tile2 == 196 || mapa[n].tiles[i][j].tile2 == 197)
                    fblend_trans (tiles [214], pantalla, j<<4,i<<4, 128);
                else if (mapa[n].tiles[i][j].tile2 == 135 || mapa[n].tiles[i][j].tile2 == 139)
                    fblend_trans (tiles [215], pantalla, j<<4,i<<4, 128);

                if (mapa[n].tiles[i][j].tile2 != -1)
                    masked_blit(tiles[mapa[n].tiles[i][j].tile2],pantalla,0,0,j<<4,i<<4,16,16);
            }

        for (i=0;i<9;i++)
            for (j=0;j<15;j++) {
                if (mapa[n].tiles[i][j].tile2 == 163)
                    fblend_add (halo_rojo, pantalla, (j<<4) - 16, (i<<4) - 16, 128);
            }
    } else if (dt == 80) {
        for (i=0;i<9;i++)
            for (j=0;j<15;j++) {
                if (mapa[n].tiles[i][j].tile2 != -1) {
                    if (mapa[n].tiles[i][j].tile2 == 29 || mapa[n].tiles[i][j].tile2 == 53 ||
                            mapa[n].tiles[i][j].tile2 == 59 || mapa[n].tiles[i][j].tile2 == 63 ||
                            mapa[n].tiles[i][j].tile2 == 83 || mapa[n].tiles[i][j].tile2 == 87 ||
                            mapa[n].tiles[i][j].tile2 == 125 || mapa[n].tiles[i][j].tile2 == 149 ||
                            mapa[n].tiles[i][j].tile2 == 155 || mapa[n].tiles[i][j].tile2 == 159 ||
                            mapa[n].tiles[i][j].tile2 == 179 || mapa[n].tiles[i][j].tile2 == 183) {
                        fblend_trans(tiles[mapa[n].tiles[i][j].tile2],pantalla,j<<4,i<<4,128);
                    } else if (mapa[n].tiles[i][j].tile2 == 39 || mapa[n].tiles[i][j].tile2 == 135) {
                        fblend_add(tiles[mapa[n].tiles[i][j].tile2],pantalla,j<<4,i<<4,128);
                    } else {
                        masked_blit(tiles[mapa[n].tiles[i][j].tile2],pantalla,0,0,j<<4,i<<4,16,16);
                    }
                }
            }
    } else {
        for (i=0;i<9;i++)
            for (j=0;j<15;j++) {
                if (mapa[n].tiles[i][j].tile2 != -1)
                    masked_blit(tiles[mapa[n].tiles[i][j].tile2],pantalla,0,0,j<<4,i<<4,16,16);

            }
    }

    if (dt == 4)
        for (i=0;i<9;i++)
            for (j=0;j<15;j++)
                if (mapa[n].tiles[i][j].tile2 == 220 || mapa[n].tiles[i][j].tile2 == 221 || mapa[n].tiles[i][j].tile2 == 226)
                    fblend_add (halo_rojo, pantalla, (j<<4) - 16, (i<<4) - 16, 64);

    if (dt==6) {
        for (i=0;i<NPLAT;i++) {
            if (plataformas[i].id != -1) {
                draw_sprite(pantalla,sprites[plataformas[i].id+plataformas[i].frame],plataformas[i].x,plataformas[i].y);
            }
        }
    }

    if (dt == 41 || dt == 6) {
        for (i=0;i<n_mvl;i++) {
            mvl[i].frame += mvl[i].ctbls;
            if (mvl[i].frame == 48 || mvl[i].frame == 80)
                mvl[i].ctbls = -mvl[i].ctbls;

            /*
            fblend_trans (sprites[166], pantalla, mvl[i].x>>8, mvl[i].y>>8, mvl[i].frame);
            fblend_trans (sprites[167], pantalla, 16+(mvl[i].x>>8), mvl[i].y>>8, mvl[i].frame);
            fblend_trans (sprites[190], pantalla, mvl[i].x>>8, 16+(mvl[i].y>>8), mvl[i].frame);
            fblend_trans (sprites[191], pantalla, 16+(mvl[i].x>>8), 16+(mvl[i].y>>8), mvl[i].frame);
            */

            fblend_add (polvo, pantalla, mvl[i].x >> 8, mvl [i].y >> 8, mvl [i].frame);

            mvl[i].x+=mvl[i].mx;
            mvl[i].y+=mvl[i].my;
            if (mvl[i].x<=-16384)
                mvl[i].x=61439;
            if (mvl[i].x>=61440)
                mvl[i].x=-16383;
            if (mvl[i].y<=-16384)
                mvl[i].y=36863;
            if (mvl[i].y>=36864)
                mvl[i].y=-16383;
        }
    }

    // Lluvia:

    if (dt==22 && yp<4 && !(yp == 0 && xp > 2)) {
        // El soplador
        if (soplador_contador == 0) {
            soplador_contador = (rand()%60)+1;
            soplador_incremento = (rand()%10) - 5;
        }

        if (soplador_value<256 && soplador_value>-256)
            soplador_value = soplador_value + soplador_incremento;
        else {
            soplador_value-=2*soplador_incremento;
            soplador_incremento=-soplador_incremento;
        }

        soplador_contador = soplador_contador-1;

        drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
        j = MAX_LLUVIA - 30;
        for (i=0;i<j;i++) {
            lluvia[i].y += 1024;					// Lluvia siempre cae
            lluvia[i].x -=	soplador_value*10;	// Fuerza del viento
            if (lluvia[i].y > 36608) lluvia[i].y=0;
            if (lluvia[i].x > 61184) lluvia[i].x-=61440;
            if (lluvia[i].x < 0) lluvia[i].x+=61440;
            line(pantalla,(lluvia[i].x)>>8,(lluvia[i].y)>>8,(lluvia[i].x-soplador_value*16)>>8,((lluvia[i].y)>>8)+lluvia[i].l,BLANCO);
        }
        drawing_mode(DRAW_MODE_SOLID,NULL,0,0);

        for (i = j;i < MAX_LLUVIA;i++) {
            lluvia[i].y += 512;					// Lluvia siempre cae
            lluvia[i].x -=	soplador_value*(rand()%10 + 10);	// Fuerza del viento
            if (lluvia[i].y > 36608) lluvia[i].y=-16384;
            if (lluvia[i].x > 61184) lluvia[i].x-=77824;
            if (lluvia[i].x < -16384) lluvia[i].x+=77824;

            fblend_add (vaho, pantalla, lluvia[i].x >> 8, lluvia[i].y >> 8, 32);
        }
        drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
    }

	// Nieve
	
	if (dt == 70) {
		for (i = 0; i < MAX_NIEVE; i ++) {
			lluvia [i].y += 1;
			lluvia [i].x += ((rand() % 3) - 1);	
			
			fblend_add (snow [lluvia [i].l], pantalla, lluvia[i].x, lluvia[i].y, 128);
			
			if (lluvia[i].y >= 144) 
				lluvia[i].y = -4;
				
			if (lluvia[i].x >= 240)
				lluvia[i].x = -3;
			else if (lluvia[i].x < -4)
				lluvia[i].x = 239;
		}	
	}

    if (trueno_activo) {
        l_trueno--;
        if (l_trueno<=0) trueno_activo=0;

        if (!(l_trueno & 1)) {
            // relmpago
            drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
            rectfill(pantalla,0,0,240,144,BLANCO);
            drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
        } else {
            // relmpago
            drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
            rectfill(pantalla,0,0,240,144,NEGRO);
            drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
        }
    }

    // Luces dinmicas sobre enemigos
    if (dt == 30) {		// Ekynox
        if (yp == 4)
            for (i=0;i<NENEM;i++)
                if (enemigos[i].id != -1)
                    fblend_add (halo, pantalla, enemigos[i].x - 16,enemigos[i].y - 16, 128);
    } else if (dt == 1) {	// Cueva Bassard
        for (i=0;i<NENEM;i++)
            if (enemigos[i].id == 102 || enemigos[i].id == 103)
                fblend_add (halo, pantalla, enemigos[i].x - 16,enemigos[i].y - 16, 128);
            else if (enemigos[i].id == 6)
                fblend_add (halo_rojo, pantalla, enemigos[i].x - 16,enemigos[i].y - 16, 64);
    } else if (dt == 5) {	// Dandellion Highs
        for (i=0;i<NENEM;i++)
            if (enemigos[i].id == 5 || enemigos[i].id == 7 || enemigos[i].id == 8 || enemigos[i].id == 9 || enemigos[i].id ==99 || enemigos[i].id ==103 || enemigos[i].id == 104)
                fblend_add (halo, pantalla, enemigos[i].x - 16,enemigos[i].y - 16, 96);
    } else if (dt == 4) {	// Pachin Poi Poi
        for (i=0;i<NENEM;i++)
            if (enemigos[i].id == 7 || enemigos[i].id == 10)
                fblend_add (halo_amarillo, pantalla, enemigos[i].x - 16 + (rand() % 3 - 1),enemigos[i].y - 16 + (rand() % 3 - 1), 96);
    } else if (dt == 80) {	// Classic
        for (i=0;i<NENEM;i++)
            if (enemigos[i].id == 101 || enemigos[i].id == 105 || enemigos[i].id == 15)
                fblend_add (halo_amarillo, pantalla, enemigos[i].x - 16 + (rand() % 3 - 1),enemigos[i].y - 16 + (rand() % 3 - 1), 96);
    }

    // Overlays:

    if ( (dt == 30 && yp == 4)) {
        fblend_trans (dark_overlay, pantalla, 0, 0, 128);
    } else if (dt == 5 && yp > 0 && xp < 2) {
        fblend_sub (fancy_overlay, pantalla, 0, 0, 128);
        fblend_sub (anti_halo, pantalla, (phantomas.x>>8)-240, (phantomas.y>>8)-144, 96);
    } else if (dt == 4 && yp == 3 && xp > 1) {
        fblend_sub (fancy_overlay, pantalla, 0, 0, 128);
    } else if (dt == 80) {
        if (yp>0 && xp<4 && !(xp==3 && yp==1)) {
            fblend_sub (anti_halo, pantalla, (phantomas.x>>8)-240, (phantomas.y>>8)-144, 128);
        } else {
            for (i=0;i<144;i++) {
                res=angle+i;
                if (res>=144) res-=144;

                if (sin_tbl[res]>=0)
                    hline(buffer_auxiliar,0,i,sin_tbl[res],getpixel(fancy_overlay_2,0,i));
                else
                    hline(buffer_auxiliar,240+sin_tbl[res],i,239,getpixel(fancy_overlay_2,239,i));

                blit(fancy_overlay_2,buffer_auxiliar,0,i,sin_tbl[res],i,240,1);
            }
            fblend_add (buffer_auxiliar, pantalla, 0, 0, 64);
            angle++;
            if (angle==144) angle=0;
        }
    } else if (dt == 41 && explosion) {
        fblend_add (war_overlay, pantalla, 0, 0, rand() & 255);
        explosion_life --;
        if (explosion_life == 0)
            explosion = 0;
    }
}

int generate_map (JUGADOR phantomas,ENEMIGO *enemigos,ENEMIGO *plataformas,MAPA mapa,OBJ *palancas,OBJ *energias,unsigned char n,\
           BITMAP *tiles[],BITMAP *sprites[],BITMAP *fondos[],BITMAP *pantalla,CABECERA cabecera) {
	
	// Esta funcin llama a render para todas las pantallas del juego y confecciona un mapa que salvamos
	// a un archivo PCX
	
	BITMAP *mimapa;
	BITMAP *auxscr;
	int x = 0, y = 0;
	int i, j;
	
	mimapa = create_bitmap (1200, 720);
	auxscr = create_bitmap (240, 144);
	
	for (i = 0; i < 25; i ++) {
		for (j=0;j<NENEM;j++) {
	        enemigos[j].x=mapa[i].enemigos[j].ini_x*16;
	        enemigos[j].y=mapa[i].enemigos[j].ini_y*16;
	
	        enemigos[j].mx=mapa[i].enemigos[j].vel * signo(mapa[i].enemigos[j].fin_x - mapa[i].enemigos[j].ini_x);
	        enemigos[j].my=mapa[i].enemigos[j].vel * signo(mapa[i].enemigos[j].fin_y - mapa[i].enemigos[j].ini_y);
	
	        enemigos[j].id=mapa[i].enemigos[j].id;
	        enemigos[j].frame=0;
	        enemigos[j].subframe = 0;
	        enemigos[j].ini_x=mapa[i].enemigos[j].ini_x*16;
	        enemigos[j].ini_y=mapa[i].enemigos[j].ini_y*16;
	        enemigos[j].fin_x=mapa[i].enemigos[j].fin_x*16;
	        enemigos[j].fin_y=mapa[i].enemigos[j].fin_y*16;
	    }
	
	    for (j=0;j<NPLAT;j++) {
	        plataformas[j].x=mapa[i].plataformas[j].ini_x*16;
	        plataformas[j].y=mapa[i].plataformas[j].ini_y*16;
	
	        plataformas[j].mx=mapa[i].plataformas[j].vel * signo(mapa[i].plataformas[j].fin_x - mapa[i].plataformas[j].ini_x);
	        plataformas[j].my=mapa[i].plataformas[j].vel * signo(mapa[i].plataformas[j].fin_y - mapa[i].plataformas[j].ini_y);
	
	        plataformas[j].id=mapa[i].plataformas[j].id;
	        plataformas[j].frame=0;
	        plataformas[j].subframe = 0;
	        plataformas[j].ini_x=mapa[i].plataformas[j].ini_x*16;
	        plataformas[j].ini_y=mapa[i].plataformas[j].ini_y*16;
	        plataformas[j].fin_x=mapa[i].plataformas[j].fin_x*16;
	        plataformas[j].fin_y=mapa[i].plataformas[j].fin_y*16;
	    }
		
		render (phantomas, enemigos, plataformas, mapa, palancas, energias, i, tiles, sprites, fondos, auxscr, cabecera);
		blit (auxscr, mimapa, 0, 0, x, y, 240, 144);
		x += 240;
		if (x == 1200) {
			x = 0;
			y += 144;
		}
	}
	
	save_pcx ("mapa.pcx", mimapa, NULL);
	
	destroy_bitmap (mimapa);
	destroy_bitmap (auxscr);
}

void blitter(BITMAP *pantalla,BITMAP *negra,BITMAP *aux) {
    int i;
    char dx, dy;

    if (config.volcado == SCANLINES) {
        stretch_blit(pantalla,aux,0,0,240,144,0,0,480,288);

        drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
        for (i=0;i<288;i+=2) {
            // draw_trans_sprite(aux,negra,0,i+1);
            hline (aux, 0, i, 480, 0);
        }
        drawing_mode(DRAW_MODE_SOLID,NULL,0,0);

        if (dt == 41 && explosion) {
            dx = rand()%3 - 1;
            dy = rand()%3 - 1;

            blit(aux,screen,0 + (dx == -1),0 + (dy == -1), 81 + (dx == 1),57 + (dy == 1), 480 - (dx != 0), 288 - (dy != 0));
        } else
            blit(aux,screen,0,0,81,57,480,288);
    } else {
        if (dt == 41 && explosion) {
            dx = rand()%3 - 1;
            dy = rand()%3 - 1;

            stretch_blit(pantalla,screen,0 + (dx == -1),0 + (dy == -1), 240, 144, 81 + (dx == 1),57 + (dy == 1), 480 - (dx != 0), 288 - (dy != 0));
        } else
            stretch_blit(pantalla,screen,0,0,240,144,81,57,480,288);
    }
}

void binary_fade_out() {
    BITMAP *buffer, *borrado, *cell;
    short x,y,i;
    unsigned char c;

    unsigned char tones[8][16]={ {0x00, 0x01, 0x11, 0x11, 0x55, 0x55, 0x55, 0x55, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF},
        {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x88, 0xAA, 0xAA, 0xAA, 0xAA, 0xEE, 0xEE, 0xEF, 0xFF, 0xFF},
        {0x00, 0x00, 0x00, 0x44, 0x44, 0x55, 0x55, 0x55, 0x77, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF},
        {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xAA, 0xAA, 0xAA, 0xBB, 0xBB, 0xFF, 0xFF, 0xFF, 0xFF},
        {0x00, 0x00, 0x11, 0x11, 0x55, 0x55, 0x55, 0x55, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF},
        {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x88, 0xAA, 0xAA, 0xAA, 0xAA, 0xEE, 0xEE, 0xFF, 0xFF, 0xFF},
        {0x00, 0x00, 0x00, 0x44, 0x44, 0x55, 0x55, 0x55, 0x77, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF},
        {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xAA, 0xAA, 0xAA, 0xBB, 0xBB, 0xFF, 0xFF, 0xFF, 0xFF}
    };

    cell=create_bitmap(8,8);

    buffer=create_bitmap(640,480);
    borrado=create_bitmap(640,480);

    blit(screen,buffer,0,0,0,0,640,480);	// Copia de la pantalla

    clear_keybuf();

    for (i=0;i<16;i++) {
        // Creamos la celda con el tramado de motivo:

        for (y=0;y<8;y++) {
            c=tones[y][i];
            for (x=0;x<8;x++)
                if ( (c & (1<<x)) == (1<<x) )	// Si el BIT est a 1...
                    putpixel(cell,x,y,0);
                else
                    putpixel(cell,x,y,makecol(255,0,255));
        }

        // Rellenamos de celdas:

        blit(buffer,borrado,0,0,0,0,640,480);

        for (y=0;y<60;y++)
            for (x=0;x<80;x++)
                draw_sprite(borrado,cell,x<<3,y<<3);

        vsync();

        blit(borrado,screen,0,0,0,0,640,480);
        //readkey(); clear_keybuf();
    }

    destroy_bitmap(buffer);
    destroy_bitmap(borrado);
    destroy_bitmap(cell);
}

void blitter_blending(BITMAP *pantalla,BITMAP *negra,BITMAP *aux, BITMAP *buffer) {
    int i;
    if (config.volcado == SCANLINES) {
        stretch_blit(pantalla,aux,0,0,240,144,0,0,480,288);

        drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
        for (i=0;i<288;i+=2) {
            // draw_trans_sprite(aux,negra,0,i+1);
            hline (aux, 0, i, 480, 0);
        }
        drawing_mode(DRAW_MODE_SOLID,NULL,0,0);

        blit(aux,buffer,0,0,81,57,480,288);
    } else {
        stretch_blit(pantalla,buffer,0,0,240,144,81,57,480,288);
    }
}

void marcador_blending(int valor, BITMAP *vacio, BITMAP *lleno, BITMAP *pantalla) {
    int vl;

    vl=((valor*205)>>8);
    if (vl>0)
        blit(lleno,pantalla,0,0,90,381,vl,16);
    if (vl<205)
        blit(vacio,pantalla,vl,0,90+vl,381,205-vl,16);
}

void binary_blending(BITMAP *nuevapantalla) {
    BITMAP *buffer, *borrado, *cell;
    short xx,yy,x,y,i;
    unsigned char c;

    //
    unsigned char tones[8][16]={{0x00, 0x01, 0x11, 0x11, 0x55, 0x55, 0x55, 0x55, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF},
        {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x88, 0xAA, 0xAA, 0xAA, 0xAA, 0xEE, 0xEE, 0xEF, 0xFF, 0xFF},
        {0x00, 0x00, 0x00, 0x44, 0x44, 0x55, 0x55, 0x55, 0x77, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF},
        {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xAA, 0xAA, 0xAA, 0xBB, 0xBB, 0xFF, 0xFF, 0xFF, 0xFF},
        {0x00, 0x00, 0x11, 0x11, 0x55, 0x55, 0x55, 0x55, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF},
        {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x88, 0xAA, 0xAA, 0xAA, 0xAA, 0xEE, 0xEE, 0xFF, 0xFF, 0xFF},
        {0x00, 0x00, 0x00, 0x44, 0x44, 0x55, 0x55, 0x55, 0x77, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF},
        {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xAA, 0xAA, 0xAA, 0xBB, 0xBB, 0xFF, 0xFF, 0xFF, 0xFF}
    };


    cell=create_bitmap(8,8);

    buffer=create_bitmap(640,480);
    borrado=create_bitmap(640,480);

    blit(screen,buffer,0,0,0,0,640,480);	// Copia de la pantalla

    clear_keybuf();

    for (i=0;i<16;i++) {
        blit(buffer,borrado,0,0,0,0,640,480);

        // Creamos la celda con el tramado de motivo:
        for (yy=0;yy<60;yy++)
            for (xx=0;xx<80;xx++) {
                for (y=0;y<8;y++) {
                    c=tones[y][i];
                    for (x=0;x<8;x++)
                        if ( (c & (1<<x)) == (1<<x) )	// Si el BIT est a 1...
                            putpixel(cell,x,y,getpixel(nuevapantalla,(xx<<3)+x,(yy<<3)+y));
                        else
                            putpixel(cell,x,y,makecol(255,0,255));
                }

                draw_sprite(borrado,cell,xx<<3,yy<<3);
            }


        vsync();

        blit(borrado,screen,0,0,0,0,640,480);
    }

    destroy_bitmap(buffer);
    destroy_bitmap(borrado);
    destroy_bitmap(cell);
}

void lineas(BITMAP *pantalla) {
    int i;

    for (i=478;i>=0;i-=2) {
        blit(pantalla,screen,0,i,0,i,640,1);
        if ((i & 3) == 0) vsync();
    }

    for (i=1;i<480;i+=2) {
        blit(pantalla,screen,0,i,0,i,640,1);
        if (((i-1) & 3) == 0) vsync();
    }
}

void cuadrados(BITMAP *pantalla) {
    BITMAP *spr = create_bitmap(16,16);
    int i=0;
    int y,x;
    int colortr;

    colortr=makecol(255,0,255);

    for (i=0;i<9;i++) {
        for (y=0;y<30;y++) {
            for (x=0;x<40;x++) {
                clear_to_color(spr,colortr);
                blit(pantalla,spr,(x<<4)+8-i,(y<<4)+8-i,8-i,8-i,(i)<<1,(i)<<1);
                draw_sprite(screen,spr,(x<<4),(y<<4));
            }
        }
        vsync();
    }

    destroy_bitmap(spr);
}

void cuadrados_r(BITMAP *pantalla) {
    BITMAP *spr = create_bitmap(16,16);
    BITMAP *buffer;
    BITMAP *volcado;
    int i=0;
    int y,x;
    int colortr;

    colortr=makecol(255,0,255);

    buffer=create_bitmap(640,480);
    volcado=create_bitmap(640,480);

    blit(screen,buffer,0,0,0,0,640,480);

    for (i=0;i<17;i++) {
        blit(buffer,volcado,0,0,0,0,640,480);

        for (y=0;y<30;y++) {
            for (x=0;x<40;x++) {
                clear_to_color(spr,colortr);
                blit(pantalla,spr,(x<<4),(y<<4),0,0,16,16);
                rotate_scaled_sprite(volcado,spr,(x<<4),(y<<4),(i<<5)<<15,i<<12);
            }
        }

        vsync();
        blit(volcado,screen,0,0,0,0,640,480);
    }

    destroy_bitmap(spr);
    destroy_bitmap(buffer);
    destroy_bitmap(volcado);
}

void v_senos(BITMAP *pantalla) {
    BITMAP *buffer;
    BITMAP *volcado;

    int incrementos[60];
    int coordenadas[60];
    int i;

    buffer=create_bitmap(640,480);
    volcado=create_bitmap(640,480);

    blit(screen,buffer,0,0,0,0,640,480);

    for (i=0;i<60;i++) {
        incrementos[i]= - 120*(1-cos(i*M_PI_2/60));
        coordenadas[i]=640;
    }

    while (coordenadas[59]>0) {
        for (i=0;i<60;i++) {
            if (incrementos[i]>0 && coordenadas[i]>0) {
                coordenadas[i]-=incrementos[i];
                if (coordenadas[i]<0)
                    coordenadas[i]=0;
            }
            incrementos[i]++;

            if (coordenadas[i]>0) {
                blit(buffer,volcado,640-coordenadas[i],i<<3,0,i<<3,coordenadas[i],8);
            }

            if (coordenadas[i]<639) {
                blit(pantalla,volcado,0,i<<3,coordenadas[i],i<<3,640-coordenadas[i],8);
            }
        }

        vsync();

        blit(volcado,screen,0,0,0,0,640,480);
    }

    destroy_bitmap(buffer);
    destroy_bitmap(volcado);
}

void efectos(BITMAP *pantalla) {
    int i;

    i=rand()%5;

    switch (i) {
    case 0:
        //binary_blending(pantalla); break;
    case 1:
        lineas(pantalla);
        break;
    case 3:
        cuadrados_r(pantalla);
        break;
    case 4:
        //v_senos(pantalla); break;
    case 2:
        cuadrados(pantalla);
        break;
    }
}

void marcador(int valor, BITMAP *vacio, BITMAP *lleno) {
    int vl;

    vl=((valor*205)>>8);
    if (vl>0)
        blit(lleno,screen,0,0,90,381,vl,16);
    if (vl<205)
        blit(vacio,screen,vl,0,90+vl,381,205-vl,16);
}

int num_palancas (BITMAP *where, BITMAP *sprites [], JUGADOR phantomas) {
    draw_sprite (where, sprites [192], 96,424);
    if (phantomas.n_palancas < 10)
        blit (numeros, where, 0, 0, 112, 424, 16, 16);
    else
        blit (numeros, where, (phantomas.n_palancas / 10) << 4, 0, 112,424, 16, 16);

    blit (numeros, where, (phantomas.n_palancas % 10) << 4, 0, 128, 424, 16, 16);
}

void restorer (void) {
	lost_focus = 1;
}

int final(BITMAP *letras [], BITMAP *negra, BITMAP *aux) {
	BITMAP *pizarra;
	
	pizarra = create_bitmap (240, 144);
	clear_to_color (pizarra, 0);
	blitter (pizarra, negra, aux);
	
	if (config.idioma == ESPANOL)
		typewriter ("Y TRAS LA PUERTA, SILENCIO Y OSCURIDAD...", letras);
	else
		typewriter ("AND, BEHIND THE DOOR, ALL IS DARK AND QUIET...", letras);
	
	if (config.idioma == ESPANOL) 
		typewriter ("HASTA QUE PHANTOMAS FIJA SU  VISTA EN UN CERCANO PUNTO LU-MINOSO, CUYO RESPLANDOR CRECEPOCO A POCO", letras);
	else
		typewriter ("UNTIL PHANTOMAS FOCUSES ON A BRIGHT SPOT CLOSE TO HIM,    WHICH SLOWLY STARTS SHINING  LIKE A LITTLE STAR", letras);
	
	destroy_bitmap (pizarra);
	pizarra = load_bitmap ("gfx/tiara1.pcx", NULL);
	blitter (pizarra, negra, aux);
	
	if (config.idioma == ESPANOL)	
		typewriter ("PHANTOMAS CONTEMPLA EXTASIA- DO LA PRECIOSA JOYA. POR FIN ES SUYA! LA MITICA TIARA DE  DIAMANTE Y ONICE!", letras);
	else
		typewriter ("PHANTOMAS STARES ASHTOUNDED  TO THE PRECIOUS JEWEL. IT IS HIS, AT LAST! THE MYTHICAL   DIAMOND AND ONIX TIARA!", letras);

	if (config.idioma == ESPANOL) 
		typewriter ("SIN EMBARGO, ALGO VA MAL EN  EL CEREBRO DE PHANTOMAS.     INEXPLICABLEMENTE, HA EMPEZA-DO A SENTIRSE MUY MAL.", letras);
	else
		typewriter ("NEVERTHELESS, SOMETHING GOES WRONG IN PHANTOMAS' BRAINS...ODDLY ENOUGH, HE STARTS FEEL-ING QUITE BAD...", letras);

	if (config.idioma == ESPANOL)
		typewriter ("PHANTOMAS ENTIENDE AL INSTAN-TE QUE LE ESTA PROVOCANDO ESESENTIMIENTO: LA TIARA! SU LUZMORTECINA PARECE PENETRARLE", letras);
	else
		typewriter ("PHANTOMAS UNDERSTANDS WHAT ISCAUSING THAT TO HIM: THE     TIARA! ITS DEADLY LIGHT SEEMSTO PENETRATE INTO HIM!", letras);
	
	destroy_bitmap (pizarra);
	pizarra = load_bitmap ("gfx/tiara2.pcx", NULL);	
	blitter (pizarra, negra, aux);
	
	if (config.idioma == ESPANOL)
		typewriter ("LA INCREIBLE ENERGIA QUE SE  DESPRENDE DE LA TIARA ESTA   CREANDO NUEVAS CONEXIONES PO-SITRONICAS EN SU CEREBRO.", letras);
	else
		typewriter ("THE TIARA THROWS OUT AN OVER-WHELMING AMOUNT OF ENERGY    WHICH CREATES NEW POSITRONIC CONNECTIONS IN HIS BRAINS.", letras);

	if (config.idioma == ESPANOL)
		typewriter ("PHANTOMAS ESTA EN CAMINO DE  DESPERTAR POR COMPLETO, DE   DEJAR DE SER UN AUTOMATA Y   TOMAR PLENA CONSCIENCIA.", letras);
	else
		typewriter ("PHANTOMAS IS ABOUT TO CHANGE COMPLETELY, STOP BEING AN    AUTHOMATON AND TAKE FULL     SELF-CONSCIOUSNESS.", letras);

	clear_to_color (pizarra, 0);
	blitter (pizarra, negra, aux);
	
	if (config.idioma == ESPANOL)
		typewriter ("DE REPENTE, TODO PARECE CLAROEN EL CEREBRO DE PHANTOMAS.  AHORA SABE QUIEN ES, POR QUE ESTA AQUI, Y QUE DEBE HACER.", letras);
	else
		typewriter ("IN A SUDDEN, EVERYTHING TURNSOUT CLEAR IN PHANTOMAS BRAINSAS NOW HE KNOWS WHO HE IS,   WHY HE IS HERE AND WHAT TO DO", letras);
		
	destroy_bitmap (pizarra);
	pizarra = load_bitmap ("gfx/tiara3.pcx", NULL);
	blitter (pizarra, negra, aux);

	if (config.idioma == ESPANOL)
		typewriter ("UNA SOLA IDEA CONTROLA AHORA LAS ACCIONES DEL ANDROIDE:   VOLVER A ANDROMEDA Y REDIMIR SUS PECADOS.", letras);
	else
		typewriter ("ONE SIMPLE IDEA CONTROLS NOW THE ANDROID'S ACTIONS: TO    COME BACK TO ANDROMEDA AND   REDEEM HIS SINS.", letras);
	
	if (config.idioma == ESPANOL)
		typewriter ("NOS VEMOS EN EL INFINITO!", letras);
	else
		typewriter ("SEE YOU IN INFINITY!", letras);	

	destroy_bitmap (pizarra);
}

int juego(char *nombre, int indicador) {
    int detalles=0;
    int mitad;
    FMUSIC_MODULE *musica;
    PALETTE nye;
    PALETTE pal;
    BITMAP *sprites[240];
    BITMAP *tiles[240];
    CABECERA cabecera;
    MAPA mapa;
    OBJ palancas[25];
    OBJ energias[25];
    BITMAP *fondos[5];
    JUGADOR phantomas;
    ENEMIGO enemigos[NENEM];
    ENEMIGO plat[NPLAT];
    int xp, yp, xpa, ypa, pantalla, pfinal;
    LOGICO terminado;
    LOGICO finalizar=FALSO;
    int ok_saving=0;
    int exito=ESCAPE;
    BITMAP *p_juego;
    BITMAP *negra;
    BITMAP *aux;
    BITMAP *pcx;
    BITMAP *vacio,*lleno;
    BITMAP *blending;
    BITMAP *letras[240];
    BITMAP *captura;
    LOGICO debug=FALSO;
    int xx,yy;	// Coordenadas ajustadas a tiles
    int i,x,y,ax;	// Coordenadas ajustadas a pxels
    int show_message=0; // Contador para el overlay de texto :?
    FSOUND_SAMPLE *s_energia,*s_salto,*s_palanca,*s_caer,*s_enemigo,*s_suelo;
    FSOUND_SAMPLE *s_info;
    LOGICO sonido_cayendo=FALSO;
    char n_musica[256];
    int channel_ciudad = 0;
    int channel_caer = 0;
    int channel_enemigo = 0;
    int pswd_has = 0;
    char pswd_str[5];

    // 20080623
    // Lo primero primero es establecer las paranoias de tejemanejes con
    // el ALT+TABeo del juego, para que no se joda t.

    background_restorer = create_bitmap (640, 480);

    set_display_switch_callback (SWITCH_OUT, restorer);
    lost_focus = 0;

    // Yast

    transparente = makecol (255, 0, 255);

    // NUEVO [25/2/02] :: sin_tbl
    for (i=0;i<144;i++) {
        sin_tbl[i]=4*sin((float)i*4*3.14159/144);
    }

    pizarra = create_bitmap(232,138);

    // Load overlay files:

    dark_overlay = load_pcx ("gfx/overlay.pcx", nye);
    fancy_overlay = load_pcx ("gfx/overlay2.pcx", nye);
    fancy_overlay_2 = load_pcx ("gfx/overlay3.pcx", nye);
    war_overlay = load_pcx ("gfx/overlay4.pcx", nye);
    halo = load_pcx ("gfx/halo.pcx", nye);
    halo_rojo = load_pcx ("gfx/halo_rojo.pcx", nye);
    halo_amarillo = load_pcx ("gfx/halo_amarillo.pcx", nye);
    vaho = load_pcx ("gfx/vaho.pcx", nye);
    polvo = load_pcx ("gfx/polvo.pcx", nye);
    anti_halo = load_pcx ("gfx/anti_halo.pcx", nye);
    numeros = load_pcx ("gfx/numeros.pcx", nye);
	snow_pcx = load_pcx ("gfx/snow.pcx", nye);

	buffer_auxiliar = create_bitmap (240, 144);
    buffer_auxiliar_2 = create_bitmap (240, 144);

	for (i = 0; i < 3; i ++) {
		snow [i] = create_bitmap (4, 4);
		blit (snow_pcx, snow [i], i<<2, 0, 0, 0, 4, 4);
	}

    musica=NULL;

    // NUEVO [17/9/01]
    // Vemos qu fase es para activar "detalle". Ms tarde se busca un archivo .XM con
    // el mismo nombre.

    // Por implementar: Proteccin para no poder cargar fases del juego como fases de
    // usuario.

    rtrim(nombre);				// Necesario viniendo del men.
    minusculas(nombre);
    /*
    	if (!strcmp(nombre,"cueva.map"))
    		detalles=1;
    	else if (!strcmp(nombre,"castle.map") || !strcmp(nombre,"retspec.map"))
    		detalles=2;
    	else if (!strcmp(nombre,"demo.map"))
    		detalles=3;
    	else if (!strcmp(nombre,"pachin.map") || !strcmp(nombre,"a.map"))
    		detalles=4;
    	else if (!strcmp(nombre,"jill.map"))
    		detalles=5;
    	else if (!strcmp(nombre,"salem.map"))
    		detalles=6;
    	else if (!strcmp(nombre,"ciudad.map"))
    		detalles=22;
    */

    // Deteccin penca para las claves

    if (!strcmp(nombre, "jill.upr")) {
        pswd_has = 1;
        strcpy (pswd_str, "ZEUS\0");
    } else if (!strcmp(nombre, "ciudad.upr")) {
        pswd_has = 1;
        strcpy (pswd_str, "DAME\0");
    } else if (!strcmp(nombre, "castle.upr")) {
        pswd_has = 1;
        strcpy (pswd_str, "WHIZ\0");
    } else if (!strcmp(nombre, "salem.upr")) {
        pswd_has = 1;
        strcpy (pswd_str, "SHAZ\0");
    } else if (!strcmp(nombre, "war.upr")) {
        pswd_has = 1;
        strcpy (pswd_str, "BOMB\0");
    } else if (!strcmp(nombre, "ekynox.upr")) {
        pswd_has = 1;
        strcpy (pswd_str, "ANKH\0");
    } else if (!strcmp(nombre, "pachin.upr")) {
        pswd_has = 1;
        strcpy (pswd_str, "POIH\0");
    }

    sprintf(n_musica,"sfx/%s",nombre);
    i=strlen(n_musica);
    n_musica[i-1]=0;
    n_musica[i-2]='m';
    n_musica[i-3]='x';

    musica = FMUSIC_LoadSong (n_musica);
    FMUSIC_SetMasterVolume (musica, config.v_musica);

    negra=create_bitmap(480,1);	// 17/9/01 -> Antes estaba mejor :-P

    aux=create_bitmap(480,288);
    captura=create_bitmap(SCREEN_W,SCREEN_H);
    p_juego=create_bitmap(240,144);
    for (i=0;i<240;i++)
        letras[i]=create_bitmap(16,16);

    recorta_tiles("GFX/menu_spr.pcx",letras);

    clear_to_color(negra,makecol(0,0,0));

    dt=detalles;

    for (i=0;i<240;i++) {
        sprites[i]=create_bitmap(16,16);
        tiles[i]=create_bitmap(16,16);
    }

    for (i=0;i<5;i++)
        fondos[i]=create_bitmap(240,144);

    clear(p_juego);

    if (!(exito=carga_fase(nombre, &cabecera, mapa, palancas, energias, fondos, tiles, sprites)))
        return(FALLO);

    if (has_efec)
        dt=n_efec;

    phantomas.x=256*16*cabecera.ini_x;
    phantomas.y=256*16*cabecera.ini_y;
    phantomas.frame=0;
    phantomas.cayendo=FALSO;
    phantomas.saltando=FALSO;
    phantomas.sobre_plataforma=FALSO;
    phantomas.contador_salto=0;
    phantomas.mira_izda=FALSO;
    phantomas.salto_largo=FALSO;
    phantomas.energia=255;
    phantomas.n_palancas=0;
    phantomas.contador_caida=0;
    phantomas.etoy_muelto=0;

    xp=cabecera.pin_x;
    yp=cabecera.pin_y;

    pfinal=5*cabecera.pfi_y+cabecera.pfi_x;

    for (i=0;i<25;i++) {
        palancas[i].on=CIERTO;
        energias[i].on=CIERTO;
    }

    pantalla=5*yp+xp;

    for (i=0;i<NENEM;i++) {
        enemigos[i].x=mapa[pantalla].enemigos[i].ini_x*16;
        enemigos[i].y=mapa[pantalla].enemigos[i].ini_y*16;

        enemigos[i].mx=mapa[pantalla].enemigos[i].vel * signo(mapa[pantalla].enemigos[i].fin_x - mapa[pantalla].enemigos[i].ini_x);
        enemigos[i].my=mapa[pantalla].enemigos[i].vel * signo(mapa[pantalla].enemigos[i].fin_y - mapa[pantalla].enemigos[i].ini_y);

        enemigos[i].id=mapa[pantalla].enemigos[i].id;
        enemigos[i].frame=0;
        enemigos[i].subframe = 0;
        enemigos[i].ini_x=mapa[pantalla].enemigos[i].ini_x*16;
        enemigos[i].ini_y=mapa[pantalla].enemigos[i].ini_y*16;
        enemigos[i].fin_x=mapa[pantalla].enemigos[i].fin_x*16;
        enemigos[i].fin_y=mapa[pantalla].enemigos[i].fin_y*16;
    }

    for (i=0;i<NPLAT;i++) {
        plat[i].x=mapa[pantalla].plataformas[i].ini_x*16;
        plat[i].y=mapa[pantalla].plataformas[i].ini_y*16;

        plat[i].mx=mapa[pantalla].plataformas[i].vel * signo(mapa[pantalla].plataformas[i].fin_x - mapa[pantalla].plataformas[i].ini_x);
        plat[i].my=mapa[pantalla].plataformas[i].vel * signo(mapa[pantalla].plataformas[i].fin_y - mapa[pantalla].plataformas[i].ini_y);

        plat[i].id=mapa[pantalla].plataformas[i].id;
        plat[i].frame=0;
        plat[i].subframe = 0;
        plat[i].ini_x=mapa[pantalla].plataformas[i].ini_x*16;
        plat[i].ini_y=mapa[pantalla].plataformas[i].ini_y*16;
        plat[i].fin_x=mapa[pantalla].plataformas[i].fin_x*16;
        plat[i].fin_y=mapa[pantalla].plataformas[i].fin_y*16;
    }


    if (dt==4) {	// Fuegos fatuos:
        for (i=0;i<10;i++) {
            mvl[i].x=(phantomas.x>>8)-16;
            mvl[i+10].x=(phantomas.x>>8)+16;
            mvl[i].y=(phantomas.y>>8)-8;
            mvl[i+10].y=(phantomas.y>>8)-8;
            mvl[i].frame=0;
            mvl[i+10].frame=0;
            mvl[i].ctbls=0;
            mvl[i+10].ctbls=0;
            ctbls=0;
        }
    } else if (dt==6 || dt == 41) {
        if (dt == 41)
            n_mvl = rand()%(MAX_MVL-4)+5;
        else
            n_mvl = rand()%((MAX_MVL>>1)-4)+5;

        for (i=0;i<n_mvl;i++) {
            mvl[i].x=((rand()%272)-32)<<8;
            mvl[i].y=((rand()%176)-32)<<8;
            mvl[i].mx=(rand()%512)-256;
            mvl[i].my=(rand()%512)-256;
            mvl[i].frame = rand() % 20 + 56;
            mvl[i].ctbls = 2 * (rand() & 1) - 1;
        }
    } else if (dt==22) {	// Inicializar la lluvia
        // Coordenadas * 256
        for (i=0;i<MAX_LLUVIA;i++) {
            lluvia[i].x=(rand()%240)<<8;
            lluvia[i].y=(rand()%144)<<8;
            lluvia[i].l=(rand()%3)+2;
        }
	} else if (dt == 70) {	// Inicializar la nieve
    	for (i = 0; i < MAX_NIEVE; i ++) {
			lluvia[i].x = (rand()%240);
			lluvia[i].y = (rand()%144);
			lluvia[i].l = (rand()%3);
		}
	}

    if (dt == 41) {
        mvl2 [0].x = (rand() % 240) << 8;
        mvl2 [0].y = -8192 - ((rand() & 31) << 12) ;
        mvl2 [0].mx = ((rand()%512) - 256) << 1;
        mvl2 [0].my = 1024;

        mvl2idx = 1;

        for (i = 1; i < MAX_MVL; i ++)
            mvl2 [i].frame = 0;
    }

    // Lucirnagas

    if (dt == 2) {
        for (i = 0; i < MAX_LUCIERNAGA; i ++) {
            luciernagas[i].x = (rand() % 240) << 8;
            luciernagas[i].y = (rand() % 144) << 8;
            luciernagas[i].mx = ((rand() % 3) - 1) * 16;
            luciernagas[i].my = ((rand() % 3) - 1) * 16;
            luciernagas[i].ax = (rand() % 8) - 4;
            luciernagas[i].ay = (rand() % 8) - 4;
            luciernagas[i].count = 0;
            luciernagas[i].nextcount = 40 + (rand() % 40);
        }
    }


    pcx=load_pcx("GFX/MARCO.PCX",pal);
    blending=create_bitmap(640,480);
    clear(blending);
    blit(pcx,blending,0,0,0,0,640,480);
    vacio=load_pcx("GFX/VIDA_EMPTY.PCX",pal);
    lleno=load_pcx("GFX/VIDA_FULL.PCX",pal);
    render(phantomas,enemigos,plat,mapa,palancas,energias,pantalla,tiles,sprites,fondos,p_juego,cabecera);
    blitter_blending(p_juego,negra,aux,blending);
    marcador_blending(phantomas.energia,vacio,lleno,blending);
    num_palancas (blending, sprites, phantomas);
    imprime_texto(blending,(SCREEN_W/2)-(strlen(cabecera.nombre.contenido)*8),12,cabecera.nombre.contenido,sprites);
    blit(blending, background_restorer, 0, 0, 0, 0, 640, 480);
    efectos(blending);

    if (dt==4) {
        ctbls=0;
        for (i=0;i<10;i++) {
            tbls[i]=(int)( (float) 2 * sin(2 * 3.1415916 * (float)i / 10) );
            tblc[i]=(int)( (float) 2 * cos(2 * 3.1415916 * (float)i / 10) );
        }
    }

    // Pintamos un rectangulo con los valores de palancas y energas de la fase:

    pinta_rectangulo(screen,160,184,479,215,CIERTO);
    if (!pswd_has)
        pinta_rectangulo(screen,160,216,479,295,CIERTO);
    else
        pinta_rectangulo(screen,160,216,479,327,CIERTO);

    pinta_rectangulo(screen,427,227,452,252,0);
    pinta_rectangulo(screen,427,259,452,284,0);

    imprime_texto(screen,(SCREEN_W/2)-(strlen(cabecera.nombre.contenido)*8),192,cabecera.nombre.contenido,letras);

    switch (config.idioma) {
    case ESPANOL:
        imprime_texto(screen,192,232,"PALANCAS",letras);
        imprime_texto(screen,192,264,"ENERGIAS",letras);
        break;
    case INGLES:
        imprime_texto(screen,192,232,"SWITCHES",letras);
        imprime_texto(screen,192,264,"POWER",letras);
        break;
    case ALEMAN:
        imprime_texto(screen,192,232,"SCHALTERE",letras);
        imprime_texto(screen,192,264,"ENERGIE",letras);
        break;
    case FRANCES:
        imprime_texto(screen,192,232,"SWITCHES",letras);
        imprime_texto(screen,192,264,"POWER",letras);
        break;
    case ITALIANO:
        imprime_texto(screen,192,232,"INTERRUTTORI",letras);
        imprime_texto(screen,192,264,"ALIMENTAZIONI",letras);
        break;
    }

    draw_sprite(screen,sprites[192],432,232);
    draw_sprite(screen,sprites[193],432,264);

    if (pswd_has) {
        imprime_texto(screen,336,296,pswd_str,letras);
        imprime_texto(screen,230,296,"PASS:",letras);
    }

    if (config.audio) {
        s_info = FSOUND_Sample_Load (FSOUND_FREE,"sfx/info.wav",FSOUND_LOOP_NORMAL | FSOUND_2D, 0, 0);
        FSOUND_PlaySound (FSOUND_FREE, s_info);
    }

    while (!key[KEY_ENTER] && !key[KEY_LCONTROL] && !key[KEY_SPACE] && !key[KEY_UP] && !key[KEY_DOWN] && !key[KEY_LEFT] && !key[KEY_RIGHT]);

    if (config.audio) {
        FSOUND_Sample_Free (s_info);
    }

    if (config.audio) {
        FMUSIC_PlaySong (musica);

        s_energia =	FSOUND_Sample_Load (FSOUND_FREE, "sfx/energia.wav", FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
        s_salto = 	FSOUND_Sample_Load (FSOUND_FREE, "sfx/salto.wav", FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
        s_palanca =	FSOUND_Sample_Load (FSOUND_FREE, "sfx/palanca.wav", FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
        s_caer = 	FSOUND_Sample_Load (FSOUND_FREE, "sfx/caer.wav", FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
        s_enemigo =	FSOUND_Sample_Load (FSOUND_FREE, "sfx/enemigo.wav", FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
        s_suelo = 	FSOUND_Sample_Load (FSOUND_FREE, "sfx/suelo.wav", FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);

        if (dt==22) {
            samples_ciudad[0] = FSOUND_Sample_Load (FSOUND_FREE, "sfx/lluvia1.wav", FSOUND_LOOP_NORMAL | FSOUND_2D, 0, 0);
            samples_ciudad[1] = FSOUND_Sample_Load (FSOUND_FREE, "sfx/lluvia2.wav", FSOUND_LOOP_NORMAL | FSOUND_2D, 0, 0);
            samples_ciudad[2] = FSOUND_Sample_Load (FSOUND_FREE, "sfx/trueno.wav", FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
        }

        if (dt == 41)
            s_bomb = FSOUND_Sample_Load (FSOUND_FREE, "sfx/bomb.wav", FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
    }

    sample_lluvia_activo = 0;

    while (!finalizar) {
        if (dt == 41) {
            mvl2 [0].x = (rand() % 240) << 8;
            mvl2 [0].y = -8192 - ((rand() & 31) << 12) ;
            mvl2 [0].mx = ((rand()%512) - 256) << 1;
            mvl2 [0].my = 1024;
            mvl2idx = 1;

            explosion = 0;
            explosion_life = 0;

            for (i = 1; i < MAX_MVL; i ++) {
                mvl2 [i].y = -8192;
                mvl2 [i].frame = 0;
            }
        }

        if (dt==22) {
            if (yp<4 && !(yp == 0 && xp > 2) ) {
                if (sample_lluvia_activo != 1) {
                    sample_lluvia_activo=1;
                    FSOUND_StopSound (channel_ciudad);
                    channel_ciudad = FSOUND_PlaySound (FSOUND_FREE, samples_ciudad[0]);
                }
            } else {
                if (sample_lluvia_activo != 2) {
                    sample_lluvia_activo=2;
                    FSOUND_StopSound (channel_ciudad);
                    channel_ciudad = FSOUND_PlaySound (FSOUND_FREE, samples_ciudad[1]);
                }
            }
        }

        if (dt == 22) {	// Inicializar la lluvia
            // Coordenadas * 256
            for (i=0;i<MAX_LLUVIA;i++) {
                lluvia[i].x=(rand()%240)<<8;
                lluvia[i].y=(rand()%144)<<8;
                lluvia[i].l=(rand()%3)+2;
            }
        }
        
        if (dt == 70) {	// Inicializar la nieve
        	for (i = 0; i < MAX_NIEVE; i ++) {
				lluvia[i].x = (rand()%240);
				lluvia[i].y = (rand()%144);
				lluvia[i].l = (rand()%3);
			}
		}

        // Rellena las estructuras de los enemigos:

        pantalla = 5 * yp + xp;

        for (i=0;i<NENEM;i++) {
            enemigos[i].x=mapa[pantalla].enemigos[i].ini_x*16;
            enemigos[i].y=mapa[pantalla].enemigos[i].ini_y*16;

            enemigos[i].mx=mapa[pantalla].enemigos[i].vel * signo(mapa[pantalla].enemigos[i].fin_x - mapa[pantalla].enemigos[i].ini_x);
            enemigos[i].my=mapa[pantalla].enemigos[i].vel * signo(mapa[pantalla].enemigos[i].fin_y - mapa[pantalla].enemigos[i].ini_y);

            enemigos[i].id=mapa[pantalla].enemigos[i].id;
            enemigos[i].frame=0;
            enemigos[i].subframe = 0;
            enemigos[i].ini_x=mapa[pantalla].enemigos[i].ini_x*16;
            enemigos[i].ini_y=mapa[pantalla].enemigos[i].ini_y*16;
            enemigos[i].fin_x=mapa[pantalla].enemigos[i].fin_x*16;
            enemigos[i].fin_y=mapa[pantalla].enemigos[i].fin_y*16;
        }

        for (i=0;i<NPLAT;i++) {
            plat[i].x=mapa[pantalla].plataformas[i].ini_x*16;
            plat[i].y=mapa[pantalla].plataformas[i].ini_y*16;

            plat[i].mx=mapa[pantalla].plataformas[i].vel * signo(mapa[pantalla].plataformas[i].fin_x - mapa[pantalla].plataformas[i].ini_x);
            plat[i].my=mapa[pantalla].plataformas[i].vel * signo(mapa[pantalla].plataformas[i].fin_y - mapa[pantalla].plataformas[i].ini_y);

            plat[i].id=mapa[pantalla].plataformas[i].id;
            plat[i].frame=0;
            plat[i].subframe = 0;
            plat[i].ini_x=mapa[pantalla].plataformas[i].ini_x*16;
            plat[i].ini_y=mapa[pantalla].plataformas[i].ini_y*16;
            plat[i].fin_x=mapa[pantalla].plataformas[i].fin_x*16;
            plat[i].fin_y=mapa[pantalla].plataformas[i].fin_y*16;
        }

        if (dt==4) {	// Fuegos fatuos:
            for (i=0;i<10;i++) {
                mvl[i].x=(phantomas.x>>8)-16;
                mvl[i+10].x=(phantomas.x>>8)+16;
                mvl[i].y=(phantomas.y>>8)-8;
                mvl[i+10].y=(phantomas.y>>8)-8;
                mvl[i].frame=0;
                mvl[i+10].frame=0;
                mvl[i].ctbls=0;
                mvl[i+10].ctbls=0;
                ctbls=0;
            }
        }

        if (dt==99) {
            for (i=0;i<144;i++)
                sin_tbl[i] = 4 * sin(4 * 3.1415916 * i / 144);
        }

        idx1 = 0;
        idx2 = 0;
        
        terminado=FALSO;
        while (!terminado) {
			
			// Si perdemos el focus, paramos todo:
			if (lost_focus) {
				blit (screen, blending, 0,0,0,0, 640,480);
				
				fblend_rect_trans (blending, 0, 0, 640, 480, 0, 128);
				
				imprime_texto (blending, 272,216, "PAUSED", letras);
				imprime_texto (blending, 136,248, "PRESS ENTER TO CONTINUE", letras);
				
				while (!key [KEY_ENTER]) {
					blit (blending, screen, 0,0,0,0, 640,480);
				}
				
				while (key [KEY_ENTER]);
				
				blit (background_restorer, screen, 0,0,0,0, 640,480);
				marcador(phantomas.energia,vacio,lleno);
				num_palancas (screen, sprites, phantomas);
				
				lost_focus = 0;	
			}
			
            // Controla si salimos pulsando ESC:

            if (key [KEY_ESC]) {
				blit (screen, blending, 0,0,0,0, 640,480);
				
				fblend_rect_trans (blending, 0, 0, 640, 480, 0, 128);
				
				imprime_texto (blending, 272,216, "PAUSED", letras);
				imprime_texto (blending, 136,248, "PRESS ENTER TO CONTINUE", letras);
				imprime_texto (blending, 136,264, "PRESS ESC   TO EXIT    ", letras);
				
				i = 0;
				
				while (key [KEY_ESC]);
				
				while (!i) {
					blit (blending, screen, 0,0,0,0, 640,480);
					if (key [KEY_ESC]) {
						i = 1;
                		terminado=CIERTO;
            			finalizar=CIERTO;
					}
					if (key [KEY_ENTER]) 
						i = 1;
				}
				
				blit (background_restorer, screen, 0,0,0,0, 640,480);
				marcador(phantomas.energia,vacio,lleno);
				num_palancas (screen, sprites, phantomas);

				while (key [KEY_ENTER] || key [KEY_ESC]);
            }

            if (key[KEY_D]) {
                debug=CIERTO;
            }

            // Movimiento de Phantomas [lo gordo]:

            // Recalcular:
            xx=(phantomas.x>>12);
            yy=(phantomas.y>>12);
            x=(phantomas.x>>8);
            y=(phantomas.y>>8);

			/*
            if (debug)
                textprintf(screen,font,0,0,makecol(255,255,255),"x %i, y %i [st]: %i [st^]: %i     ",phantomas.x,phantomas.y,mapa[pantalla].tiles[yy][xx].status,mapa[pantalla].tiles[yy-1][xx].status);
			*/
			
            xpa=xp;
            ypa=yp;

            if (phantomas.saltando) {
                // Incrementa el contador de salto y
                // cambia las coordenadas de phantomas. [OK]
                // Comprueba si nos posamos sobre algn tile para para el salto. [OK]
                // Comprueba que phantomas salga por la izquierda o por la derecha [OK]
                // Comprueba que phantomas salga por arriba o por abajo [OK]
                // y hace las gestiones necesarias. [OK]

                // Movimiento vertical:

                if (phantomas.salto_largo) {	// SALTO LARGO
                    if (phantomas.contador_salto<16) {	// Subiendo, comprobar si podemos
                        if ((yy<<4) == y && yy!=0) {	// A borde de recuadro, mirar
                            if ((xx<<4) == x || xx == 14) {
                                if ((mapa[pantalla].tiles[yy-1][xx].status & 1) != 1)
                                    phantomas.y+=incL[phantomas.contador_salto];
                            } else {
                                if ((mapa[pantalla].tiles[yy-1][xx].status & 1) != 1 && (mapa[pantalla].tiles[yy-1][xx+1].status & 1) != 1)
                                    phantomas.y+=incL[phantomas.contador_salto];
                            }
                        } else {
                            phantomas.y+=incL[phantomas.contador_salto];
                        }
                        // Problema de incrementos variables, solucin al canto:
                        // Si hemos entrado en un tile - bloque, directamente ajustamos
                        // al tile inferior.
                        xx=(phantomas.x>>12);
                        yy=(phantomas.y>>12);
                        x=(phantomas.x>>8);
                        y=(phantomas.y>>8);

                        if (yy>=0) {

                            if ((xx<<4) == x || xx == 14) {
                                if ((mapa[pantalla].tiles[yy][xx].status & 1) == 1)
                                    phantomas.y=((yy+1)<<12);
                            } else {
                                if ((mapa[pantalla].tiles[yy][xx].status & 1) == 1 || (mapa[pantalla].tiles[yy][xx+1].status & 1) == 1)
                                    phantomas.y=((yy+1)<<12);
                            }
                        }
                    } else { // Bajando
                        phantomas.y+=incL[phantomas.contador_salto];
                    }
                    phantomas.contador_salto++;
                    if (phantomas.contador_salto==32) {
                        phantomas.y=((phantomas.y>>8)<<8); //Ajustar a las coordenadas
                        phantomas.x=((phantomas.x>>9)<<9);
                        phantomas.contador_salto=0;
                        phantomas.saltando=FALSO;
                    }
                } else {	// SALTO ALTO
                    if (phantomas.contador_salto<16) {	// Subiendo, comprobar si podemos
                        if ((yy<<4) == y && yy!=0) {	// A borde de recuadro, mirar
                            if ((xx<<4) == x || xx == 14) {
                                if ((mapa[pantalla].tiles[yy-1][xx].status & 1) != 1)
                                    phantomas.y+=incA[phantomas.contador_salto];
                            } else {
                                if ((mapa[pantalla].tiles[yy-1][xx].status & 1) != 1 && (mapa[pantalla].tiles[yy-1][xx+1].status & 1) != 1)
                                    phantomas.y+=incA[phantomas.contador_salto];
                            }
                        } else {
                            phantomas.y+=incA[phantomas.contador_salto];
                        }

                        // Problema de incrementos variables, solucin al canto:
                        // Si hemos entrado en un tile - bloque, directamente ajustamos
                        // al tile inferior.
                        xx=(phantomas.x>>12);
                        yy=(phantomas.y>>12);
                        x=(phantomas.x>>8);
                        y=(phantomas.y>>8);

                        if (yy>=0) {
                            if ((xx<<4) == x || xx == 14) {
                                if ((mapa[pantalla].tiles[yy][xx].status & 1) == 1) {
                                    phantomas.y=((yy+1)<<12);
                                }
                            } else {
                                if (((mapa[pantalla].tiles[yy][xx].status & 1) == 1) || ((mapa[pantalla].tiles[yy][xx+1].status & 1) == 1)) {
                                    phantomas.y=((yy+1)<<12);
                                }
                            }
                        }
                    } else { // Bajando
                        phantomas.y+=incA[phantomas.contador_salto];
                    }
                    phantomas.contador_salto++;
                    if (phantomas.contador_salto==32) {
                        phantomas.y=((phantomas.y>>8)<<8); //Ajustar a las coordenadas
                        phantomas.x=((phantomas.x>>9)<<9);		// Ajusta a mltiplo de 512						phantomas.contador_salto=0;
                        phantomas.saltando=FALSO;
                    }
                }

                // Recalcular:
                xx=(phantomas.x>>12);
                yy=(phantomas.y>>12);
                x=(phantomas.x>>8);
                y=(phantomas.y>>8);

                // Plataformas:

                for (i=0;i<NPLAT;i++)
                    if (plat[i].id != -1) {
                        // Comprobamos si phantomas est sobre una plataforma mvil,
                        // en ese caso paramos la cada y desplazamos a phantomas junto
                        // con la plataforma

                        if (plat[i].mx!=0) {	// La plataforma se mueve horizontalmente.
                            // Ver si podemos 'capturar' a Phantomas.
                            // esto ocurre si phantomas est aqu:
                            //    x-15      x      x+15
                            //     [--------[XXXXXX|]------]
                            // Y separado de 1 a 4 pxels del extremo superior de la
                            // plataforma:

                            if (x>=plat[i].x-15 && x<=plat[i].x+15 && y>=plat[i].y-19 && y<=plat[i].y-16 && phantomas.contador_salto >2) {
                                // 'atrapamos' a phantomas:
                                phantomas.saltando=FALSO;
                                phantomas.y=((plat[i].y-16)<<8);

                                xx=(phantomas.x>>12);
                                yy=(phantomas.y>>12);
                                x=(phantomas.x>>8);
                                y=(phantomas.y>>8);

                                // Vemos si podemos arrastrar a phantomas junto con la plataforma:
                                ax=((x+plat[i].mx)>>4);	// Tile que ocupara tras el movimiento

                                if (plat[i].mx<0) {	// Hacia la izquierda
                                    if ( (yy<<4) == y) {
                                        if ( ((mapa[pantalla].tiles[yy][ax].status & 1) != 1) && ((mapa[pantalla].tiles[yy][ax].status & 16) != 16) )
                                            phantomas.x+=(plat[i].mx<<8);
                                    } else {
                                        if ( ((mapa[pantalla].tiles[yy][ax].status & 1) != 1) && ((mapa[pantalla].tiles[yy+1][ax].status & 1) != 1 ) && ((mapa[pantalla].tiles[yy][ax].status & 16) != 16) && ((mapa[pantalla].tiles[yy+1][ax].status & 16) != 16 ))
                                            phantomas.x+=(plat[i].mx<<8);
                                    }
                                } else {	// Hacia la derecha
                                    if ( (yy<<4) == y) {
                                        if ( ((mapa[pantalla].tiles[yy][ax+1].status & 1) != 1) && ((mapa[pantalla].tiles[yy][ax+1].status & 16) != 16))
                                            phantomas.x+=(plat[i].mx<<8);
                                    } else {
                                        if ( ((mapa[pantalla].tiles[yy][ax+1].status & 1) != 1) && ((mapa[pantalla].tiles[yy+1][ax].status & 1) != 1 ) && ((mapa[pantalla].tiles[yy][ax+1].status & 16) != 16) && ((mapa[pantalla].tiles[yy+1][ax].status & 16) != 16 ) )
                                            phantomas.x+=(plat[i].mx<<8);
                                    }
                                }
                            }
                        } else {	// La plataforma se mueve verticalmente.
                            // Ver si podemos 'capturar' a Phantomas.
                            // esto ocurre si phantomas est aqu:
                            //    x-15      x      x+15
                            //     [--------[XXXXXX|]------]
                            // Y separado de 1 a 4 pxels del extremo superior de la
                            // plataforma:

                            if (x>=plat[i].x-15 && x<=plat[i].x+15 && y>=plat[i].y-18 && y<=plat[i].y-14) {
                                // 'atrapamos' a phantomas:
                                phantomas.saltando=FALSO;

                                // Vemos si podemos arrastrar a phantomas:
                                ax=((y+plat[i].my)>>4);

                                if (plat[i].my<0) {	// hacia arriba
                                    if ( (xx<<4) == x) {
                                        if ( (mapa[pantalla].tiles[ax][xx].status & 1)!= 1)
                                            phantomas.y=((plat[i].y-16+plat[i].my)<<8);
                                    } else {
                                        if ( ((mapa[pantalla].tiles[ax][xx].status & 1)!= 1) && ((mapa[pantalla].tiles[ax][xx+1].status & 1)!= 1) )
                                            phantomas.y=((plat[i].y-16+plat[i].my)<<8);
                                    }
                                } else {	// hacia abajo
                                    if ( (xx<<4) == x) {
                                        if ( (mapa[pantalla].tiles[ax+1][xx].status & 1)!= 1)
                                            phantomas.y=((plat[i].y-16+plat[i].my)<<8);
                                    } else {
                                        if ( ((mapa[pantalla].tiles[ax+1][xx].status & 1)!= 1) && ((mapa[pantalla].tiles[ax+1][xx+1].status & 1)!= 1) )
                                            phantomas.y=((plat[i].y-16+plat[i].my)<<8);
                                    }
                                }
                            }
                        }
                    }

                // Comprobamos si nos posamos:

                if (phantomas.contador_salto>=mitad) {
                    if ((yy<<4)==y && yy!=8) {
                        if ( ((mapa[pantalla].tiles[yy+1][xx].status & 1) == 1) || ((mapa[pantalla].tiles[yy+1][xx].status & 16) == 16) ) {
                            phantomas.y=((phantomas.y>>8)<<8); //Ajustar a las coordenadas
                            phantomas.saltando=FALSO;
                            phantomas.x=((phantomas.x>>9)<<9); // Ajusta a mltiplo de 512
                            phantomas.frame=0;
                        }
                        if ((xx<<4) != x && xx != 14)
                            if ( ((mapa[pantalla].tiles[yy+1][xx+1].status & 1 == 1)) || ((mapa[pantalla].tiles[yy+1][xx+1].status & 16) == 16) ) {
                                phantomas.y=((phantomas.y>>8)<<8); //Ajustar a las coordenadas
                                phantomas.saltando=FALSO;
                                phantomas.x=((phantomas.x>>9)<<9);	// Ajusta a mltiplo de 512
                                phantomas.frame=0;
                            }
                    } else {
                        // A veces, debido a los incrementos variables, puede que se sobrepase la plataforma.
                        // en ese caso, habr que ajustar (esto ocurre, por ejemplo, en JILL y GAIA):
                        if ( ((mapa[pantalla].tiles[yy+1][xx].status & 1) == 1) || ((mapa[pantalla].tiles[yy+1][xx].status & 16) == 16) ) {
                            phantomas.y=((phantomas.y>>12)<<12);
                            phantomas.saltando=FALSO;
                            phantomas.x=((phantomas.x>>9)<<9);		// Ajusta a mltiplo de 512
                            phantomas.frame=0;
                        }
                        if ((xx<<4) != x && xx != 14) {
                            if ( ((mapa[pantalla].tiles[yy+1][xx].status & 1 == 1)) || ((mapa[pantalla].tiles[yy+1][xx].status & 16) == 16) || ((mapa[pantalla].tiles[yy+1][xx+1].status & 1 == 1)) || ((mapa[pantalla].tiles[yy+1][xx+1].status & 16) == 16)) {
                                phantomas.y=((phantomas.y>>12)<<12);
                                phantomas.saltando=FALSO;
                                phantomas.x=((phantomas.x>>9)<<9);		// Ajusta a mltiplo de 512
                                phantomas.frame=0;
                            }
                        }
                    }
                }

                // Comprobamos si salimos de la pantalla por arriba
                if (phantomas.y<0) {
                    if (yp>0) {
                        phantomas.y=32768+phantomas.y;		// 32768=8*16*256, coordenada inf.
                        yp=yp-1;
                        terminado=CIERTO;
                    } else {
                        phantomas.y=0;		// Ajustar si no podemos salir por arriba.
                    }
                }

                // Comprobamos si salimos de la pantalla por abajo

                if (phantomas.y>32768) {
                    if (yp<4) {
                        phantomas.y=0;		// Movemos arriba
                        yp=yp+1;
                        terminado=CIERTO;
                    } else {
                        phantomas.y=32768; 	// Ajustar si no podemos salir por abajo
                    }
                }

                // Movimiento horizontal

                ax=((x>>1)<<1);

                if (phantomas.mira_izda) {
                    if ((xx<<4) == ax && xx != 0) {
                        if ((yy<<4) == y || yy == 8) {	// Mirar solo en el recuadro izquierdo
                            if ((mapa[pantalla].tiles[yy][xx-1].status & 1) != 1) {
                                phantomas.x-=(256+(phantomas.salto_largo<<8));
                            }

                        } else {	// Mirar, adems, en el inferior izquierdo.
                            if ((mapa[pantalla].tiles[yy][xx-1].status & 1) != 1 && (mapa[pantalla].tiles[yy+1][xx-1].status & 1) != 1) {
                                phantomas.x-=(256+(phantomas.salto_largo<<8));
                            }

                        }
                    } else {
                        phantomas.x-=(256+(phantomas.salto_largo<<8));
                    }

                } else {
                    if ((xx<<4) == ax && xx != 14) {
                        if ((yy<<4) == y || yy == 8) {	// Mirar solo en el recuadro derecho
                            if ((mapa[pantalla].tiles[yy][xx+1].status & 1) != 1) {
                                phantomas.x+=(256+(phantomas.salto_largo<<8));
                            }

                        } else {	// Mirar, adems, en el inferior izquierdo.
                            if ((mapa[pantalla].tiles[yy][xx+1].status & 1) != 1 && (mapa[pantalla].tiles[yy+1][xx+1].status & 1) != 1) {
                                phantomas.x+=(256+(phantomas.salto_largo<<8));
                            }
                        }
                    } else {
                        phantomas.x+=(256+(phantomas.salto_largo<<8));
                    }
                }

                // Comprobamos si salimos de la pantalla por la izquierda o por la derecha

                if (phantomas.x<0) {
                    if (xp>0) {
                        xp--;
                        phantomas.x=57344;		// Ajustar a la derecha
                        terminado=CIERTO;
                    } else
                        phantomas.x=0;
                }

                if (phantomas.x>57344) {
                    if (xp<4) {
                        xp++;
                        phantomas.x=0;						// Ajustar a la izquierda
                        terminado=CIERTO;
                    } else
                        phantomas.x=57344;
                }
            } else {
                phantomas.cayendo = CIERTO;

                // Tratemos de parar al phantomas
                // Detectar obstculos o plataformas debajo, adems de plataformas
                // mviles.

                if ((yy<<4) == y && yy!=8) {	// Solo si est justo en el recuadro
                    if ((xx<<4) == x || xx == 14) {	// Comprueba solo debajo:
                        // Vemos qu tile hay debajo y:
                        // 1. Paramos la cada

                        if ((mapa[pantalla].tiles[yy+1][xx].status & 1) == 1  ||  (mapa[pantalla].tiles[yy+1][xx].status & 16) == 16 ) {
                            phantomas.cayendo=FALSO;

                            // 2. Si es un tile que desplaza vemos si podemos o no desplazar.

                            // A la derecha:
                            if ((mapa[pantalla].tiles[yy+1][xx].status & 4) == 4) {
                                if ((xx<<4) == x && xx != 14) {
                                    if ((mapa[pantalla].tiles[yy][xx+1].status & 1) != 1)
                                        phantomas.x+=256;
                                } else {
                                    phantomas.x+=256;
                                }
                            }
                            // A la izquierda:
                            else if ((mapa[pantalla].tiles[yy+1][xx].status & 8) == 8) {
                                if ((xx<<4) == x && xx != 0) {
                                    if ((mapa[pantalla].tiles[yy][xx-1].status & 1) != 1)
                                        phantomas.x-=256;
                                } else {
                                    phantomas.x-=256;
                                }
                            }

                            // Comprobamos si salimos de la pantalla por la izquierda o por la derecha

                            if (phantomas.x<0) {
                                if (xp>0) {
                                    xp--;
                                    phantomas.x=57344;		// Ajustar a la derecha
                                    terminado=CIERTO;
                                } else
                                    phantomas.x=0;
                            }

                            if (phantomas.x>57344) {
                                if (xp<4) {
                                    xp++;
                                    phantomas.x=0;						// Ajustar a la izquierda
                                    terminado=CIERTO;
                                } else
                                    phantomas.x=57344;
                            }
                        }
                    } else {								// Comprueba debajo y debajo a la der.
                        // Vemos qu tile hay debajo y debajo a la der. y:
                        // 1. Paramos la cada

                        if ((mapa[pantalla].tiles[yy+1][xx].status & 1) == 1  ||  (mapa[pantalla].tiles[yy+1][xx].status & 16) == 16  ||  (mapa[pantalla].tiles[yy+1][xx+1].status & 1) == 1  ||  (mapa[pantalla].tiles[yy+1][xx+1].status & 16) == 16 ) {
                            phantomas.cayendo=FALSO;

                            // 2. Si es un tile que desplaza vemos si podemos o no desplazar.

                            // A la derecha:
                            if ((mapa[pantalla].tiles[yy+1][xx].status & 4) == 4 || (mapa[pantalla].tiles[yy+1][xx+1].status & 4) == 4) {
                                if ((xx<<4) == x && xx != 14) {
                                    if ((mapa[pantalla].tiles[yy][xx+1].status & 1) != 1)
                                        phantomas.x+=256;
                                } else {
                                    phantomas.x+=256;
                                }
                            }
                            // A la izquierda:
                            else if ((mapa[pantalla].tiles[yy+1][xx].status & 8) == 8 || (mapa[pantalla].tiles[yy+1][xx+1].status & 8) == 8 ) {
                                if ((xx<<4) == x && xx != 0) {
                                    if ((mapa[pantalla].tiles[yy][xx-1].status & 1) != 1)
                                        phantomas.x-=256;
                                } else {
                                    phantomas.x-=256;
                                }
                            }

                            // Comprobamos si salimos de la pantalla por la izquierda o por la derecha

                            if (phantomas.x<0) {
                                if (xp>0) {
                                    xp--;
                                    phantomas.x=57344;		// Ajustar a la derecha
                                    terminado=CIERTO;
                                } else
                                    phantomas.x=0;
                            }

                            if (phantomas.x>57344) {
                                if (xp<4) {
                                    xp++;
                                    phantomas.x=0;						// Ajustar a la izquierda
                                    terminado=CIERTO;
                                } else
                                    phantomas.x=57344;
                            }
                        }
                    }
                }

                // Plataformas mviles.

                xx=(phantomas.x>>12);
                yy=(phantomas.y>>12);
                x=(phantomas.x>>8);
                y=(phantomas.y>>8);

                for (i=0;i<NPLAT;i++)
                    if (plat[i].id != -1) {
                        // Comprobamos si phantomas est sobre una plataforma mvil,
                        // en ese caso paramos la cada y desplazamos a phantomas junto
                        // con la plataforma

                        if (plat[i].mx!=0) {	// La plataforma se mueve horizontalmente.
                            // Ver si podemos 'capturar' a Phantomas.
                            // esto ocurre si phantomas est aqu:
                            //    x-15      x      x+15
                            //     [--------[XXXXXX|]------]
                            // Y separado de 1 a 4 pxels del extremo superior de la
                            // plataforma:

                            if (x>=plat[i].x-15 && x<=plat[i].x+15 && y>=plat[i].y-19 && y<=plat[i].y-16) {
                                // 'atrapamos' a phantomas:
                                phantomas.cayendo=FALSO;
                                phantomas.y=((plat[i].y-16)<<8);

                                xx=(phantomas.x>>12);
                                yy=(phantomas.y>>12);
                                x=(phantomas.x>>8);
                                y=(phantomas.y>>8);

                                // Vemos si podemos arrastrar a phantomas junto con la plataforma:
                                ax=((x+plat[i].mx)>>4);	// Tile que ocupara tras el movimiento

                                if (plat[i].mx<0) {	// Hacia la izquierda
                                    if ( (yy<<4) == y) {
                                        if ( (mapa[pantalla].tiles[yy][ax].status & 1) != 1 )
                                            phantomas.x+=(plat[i].mx<<8);
                                    } else {
                                        if ( ((mapa[pantalla].tiles[yy][ax].status & 1) != 1) && ((mapa[pantalla].tiles[yy+1][ax].status & 1) != 1 ) )
                                            phantomas.x+=(plat[i].mx<<8);
                                    }
                                } else {	// Hacia la derecha
                                    if ( (yy<<4) == y) {
                                        if ( (mapa[pantalla].tiles[yy][ax+1].status & 1) != 1 )
                                            phantomas.x+=(plat[i].mx<<8);
                                    } else {
                                        if ( ((mapa[pantalla].tiles[yy][ax+1].status & 1) != 1) && ((mapa[pantalla].tiles[yy+1][ax].status & 1) != 1 ) )
                                            phantomas.x+=(plat[i].mx<<8);
                                    }
                                }
                            }
                        } else {	// La plataforma se mueve verticalmente.
                            // Ver si podemos 'capturar' a Phantomas.
                            // esto ocurre si phantomas est aqu:
                            //    x-15      x      x+15
                            //     [--------[XXXXXX|]------]
                            // Y separado de 1 a 4 pxels del extremo superior de la
                            // plataforma:

                            if (x>=plat[i].x-15 && x<=plat[i].x+15 && y>=plat[i].y-19 && y<=plat[i].y-14) {
                                // 'atrapamos' a phantomas:

                                // Vemos si podemos arrastrar a phantomas:
                                ax=((y+plat[i].my)>>4);

                                if (plat[i].my<0) {	// hacia arriba
                                    if ( (xx<<4) == x) {
                                        if ( (mapa[pantalla].tiles[ax][xx].status & 1)!= 1)
                                            phantomas.y=((plat[i].y-16+plat[i].my)<<8);
                                    } else {
                                        if ( ((mapa[pantalla].tiles[ax][xx].status & 1)!= 1) && ((mapa[pantalla].tiles[ax][xx+1].status & 1)!= 1) )
                                            phantomas.y=((plat[i].y-16+plat[i].my)<<8);
                                    }
                                } else {	// hacia abajo
                                    if ( (xx<<4) == x) {
                                        if ( (mapa[pantalla].tiles[ax+1][xx].status & 1)!= 1)
                                            phantomas.y=((plat[i].y-16+plat[i].my)<<8);
                                    } else {
                                        if ( ((mapa[pantalla].tiles[ax+1][xx].status & 1)!= 1) && ((mapa[pantalla].tiles[ax+1][xx+1].status & 1)!= 1))
                                            phantomas.y=((plat[i].y-16+plat[i].my)<<8);
                                    }
                                }
                                phantomas.cayendo=FALSO;
                            }
                        }
                    }

                // Caso especial:
                if (yp==4 && yy==8) phantomas.cayendo=FALSO;

                if (phantomas.cayendo) {
                    phantomas.y=(phantomas.y>>10)<<10; // Ajuste:
                    phantomas.y+=1024;

                    xx=(phantomas.x>>12);
                    yy=(phantomas.y>>12);
                    x=(phantomas.x>>8);
                    y=(phantomas.y>>8);

                    if ( yy < 8 )
                        if ( (xx<<4) == x ) {
                            if ( (mapa[pantalla].tiles[yy+1][xx].status & 1) == 1)
                                phantomas.y=(yy<<12);
                        } else {
                            if ( ((mapa[pantalla].tiles[yy+1][xx].status & 1) == 1) || ((mapa[pantalla].tiles[yy+1][xx+1].status & 1) == 1) )
                                phantomas.y=(yy<<12);
                        }

                    if (phantomas.contador_caida>4) {
                        phantomas.frame+=24;

                        if (!sonido_cayendo) {
                            if (config.audio)
                                channel_caer = FSOUND_PlaySound (FSOUND_FREE, s_caer);
                            sonido_cayendo=CIERTO;
                        }

                        if (phantomas.frame==96)
                            phantomas.frame=0;
                    } else {
                        phantomas.frame=0;
                        phantomas.contador_caida++;
                    }

                    // Comprobamos si salimos de la pantalla por abajo

                    if (phantomas.y>32768) {
                        if (yp<4) {
                            phantomas.y=0;		// Movemos arriba
                            yp=yp+1;
                            terminado=CIERTO;
                        } else {
                            phantomas.y=32768; 	// Ajustar si no podemos salir por abajo
                        }
                    }
                } else {
                    phantomas.contador_caida=0;

                    if (config.audio) {
                        if (sonido_cayendo) {
                            FSOUND_StopSound (channel_caer);
                            FSOUND_PlaySound (FSOUND_FREE, s_suelo);
                        }
                        sonido_cayendo=FALSO;
                    }

                    // Movimiento lateral:
                    // Mira si se pulsan las teclas de movimiento lateral y mueve
                    // a phantomas en el sentido correcto.
                    // Comprueba tambin si phantomas sale por la izq o por la der
                    // y hace las gestiones necesarias.
                    // Activa el salto si se pulsan las teclas

                    if (key[KEY_LEFT] || key[KEY_O]) {			// Izquierda
                        if (phantomas.x != ((phantomas.x>>9)<<9))
                            phantomas.x=((phantomas.x>>9)<<9) + 512;
                        phantomas.frame+=24;

                        if (phantomas.frame==96)
                            phantomas.frame=0;

                        phantomas.mira_izda=CIERTO;

                        if ((xx<<4) == x && xx != 0) {
                            if ((yy<<4) == y || yy == 8) {	// Mirar solo en el recuadro izquierdo
                                if ((mapa[pantalla].tiles[yy][xx-1].status & 1) != 1)
                                    phantomas.x-=512;
                            } else {	// Mirar, adems, en el inferior izquierdo.
                                if ((mapa[pantalla].tiles[yy][xx-1].status & 1) != 1 && (mapa[pantalla].tiles[yy+1][xx-1].status & 1) != 1)
                                    phantomas.x-=512;
                            }
                        } else
                            phantomas.x-=512;
                    } else if (key[KEY_RIGHT] || key[KEY_P]) {	// Derecha
                        phantomas.x=(phantomas.x>>9)<<9;		// Ajusta a mltiplo de 512
                        phantomas.frame+=24;

                        if (phantomas.frame==96)
                            phantomas.frame=0;

                        phantomas.mira_izda=FALSO;

                        if ((xx<<4) == x && xx != 14) {
                            if ((yy<<4) == y || yy == 8) {	// Mirar solo en el recuadro derecho
                                if ((mapa[pantalla].tiles[yy][xx+1].status & 1) != 1)
                                    phantomas.x+=512;
                            } else {	// Mirar, adems, en el inferior izquierdo.
                                if ((mapa[pantalla].tiles[yy][xx+1].status & 1) != 1 && (mapa[pantalla].tiles[yy+1][xx+1].status & 1) != 1)
                                    phantomas.x+=512;
                            }
                        } else
                            phantomas.x+=512;
                    }

                    // Comprobamos si salimos de la pantalla por la izquierda o por la derecha
                    if (phantomas.x<0) {
                        if (xp>0) {
                            xp--;
                            phantomas.x=57344;		// Ajustar a la derecha
                            terminado=CIERTO;
                        } else
                            phantomas.x=0;
                    }

                    if (phantomas.x>57344) {
                        if (xp<4) {
                            xp++;
                            phantomas.x=0;						// Ajustar a la izquierda
                            terminado=CIERTO;
                        } else
                            phantomas.x=57344;
                    }

                    /* */

                    if (key[KEY_UP] || key[KEY_Q] || key[KEY_RSHIFT]) {			// Salto alto
                        if (config.audio)
                            FSOUND_PlaySound (FSOUND_FREE, s_salto);

                        phantomas.x=(phantomas.x>>9)<<9;		// Ajusta a mltiplo de 512
                        phantomas.saltando=CIERTO;
                        phantomas.salto_largo=FALSO;
                        phantomas.contador_salto=0;
                        mitad=16;
                    } else if (key[KEY_DOWN] || key[KEY_A] || key[KEY_LSHIFT]) {	// Salto largo
                        if (config.audio)
                            FSOUND_PlaySound (FSOUND_FREE, s_salto);

                        phantomas.x=(phantomas.x>>9)<<9;		// Ajusta a mltiplo de 512						phantomas.saltando=CIERTO;
                        phantomas.saltando=CIERTO;
                        phantomas.salto_largo=CIERTO;
                        phantomas.contador_salto=0;
                        mitad=16;
                    }
                }
            }

            // Mover los enemigos y plataformas:

            for (i=0;i<NENEM;i++) {
                if (enemigos[i].id!=-1) {
                    enemigos[i].subframe++;
                    if (enemigos[i].subframe == 4) {
                        enemigos[i].frame+=24;
                        if (enemigos[i].frame==96) enemigos[i].frame=0;
                        enemigos[i].subframe = 0;
                    }

                    enemigos[i].x=enemigos[i].x+enemigos[i].mx;
                    enemigos[i].y=enemigos[i].y+enemigos[i].my;

                    if (enemigos[i].x == enemigos[i].ini_x ||  enemigos[i].x == enemigos[i].fin_x)
                        enemigos[i].mx=-enemigos[i].mx;

                    if (enemigos[i].y == enemigos[i].ini_y ||  enemigos[i].y == enemigos[i].fin_y)
                        enemigos[i].my=-enemigos[i].my;
                }
            }

            for (i=0;i<NENEM;i++) {
                if (plat[i].id!=-1) {
                    plat[i].subframe++;
                    if (plat[i].subframe == 4) {
                        plat[i].frame+=24;
                        if (plat[i].frame==96) plat[i].frame=0;
                        plat[i].subframe = 0;
                    }

                    plat[i].x=plat[i].x+plat[i].mx;
                    plat[i].y=plat[i].y+plat[i].my;

                    if (plat[i].x == plat[i].ini_x ||  plat[i].x == plat[i].fin_x)
                        plat[i].mx=-plat[i].mx;

                    if (plat[i].y == plat[i].ini_y ||  plat[i].y == plat[i].fin_y)
                        plat[i].my=-plat[i].my;
                }
            }

            // Vuelca:
            render(phantomas,enemigos,plat,mapa,palancas,energias,pantalla,\
                   tiles,sprites,fondos,p_juego,cabecera);

            // Colisiones:

            x=(phantomas.x>>8);
            y=(phantomas.y>>8);
            xx=x>>4;
            yy=y>>4;

            if (xp!=xpa || yp!=ypa) {
                pantalla=5*yp+xp;

                for (i=0;i<NENEM;i++) {
                    enemigos[i].x=mapa[pantalla].enemigos[i].ini_x*16;
                    enemigos[i].y=mapa[pantalla].enemigos[i].ini_y*16;

                    enemigos[i].mx=mapa[pantalla].enemigos[i].vel * signo(mapa[pantalla].enemigos[i].fin_x - mapa[pantalla].enemigos[i].ini_x);
                    enemigos[i].my=mapa[pantalla].enemigos[i].vel * signo(mapa[pantalla].enemigos[i].fin_y - mapa[pantalla].enemigos[i].ini_y);

                    enemigos[i].id=mapa[pantalla].enemigos[i].id;
                    enemigos[i].frame=0;
                    enemigos[i].ini_x=mapa[pantalla].enemigos[i].ini_x*16;
                    enemigos[i].ini_y=mapa[pantalla].enemigos[i].ini_y*16;
                    enemigos[i].fin_x=mapa[pantalla].enemigos[i].fin_x*16;
                    enemigos[i].fin_y=mapa[pantalla].enemigos[i].fin_y*16;
                }
            }

            // 1. Con los enemigos:

            for (i=0;i<NENEM;i++) {
                if (enemigos[i].id!=-1) {
                    if (x>=enemigos[i].x-15 && x<=enemigos[i].x+15 && y>=enemigos[i].y-15 && y<=enemigos[i].y+15) {
                        if (dt != 4 || enemigos[i].id != 10) {
                            if (config.audio) {
                                FSOUND_StopSound (channel_enemigo);
                                channel_enemigo = FSOUND_PlaySound (FSOUND_FREE, s_enemigo);
                            }

                            phantomas.energia--;
                            marcador(phantomas.energia,vacio,lleno);
                        }
                    }
                }
            }

            // 2. Con las palancas

            for (i=0;i<25;i++) {
                if (palancas[i].n == pantalla) {
                    if (x>=(palancas[i].x<<4)-15 && x<=(palancas[i].x<<4)+15 && y>=(palancas[i].y<<4)-15 && y<=(palancas[i].y<<4)+15 && palancas[i].on) {
                        if (config.audio)
                            FSOUND_PlaySound (FSOUND_FREE, s_palanca);

                        phantomas.n_palancas++;
                        palancas[i].on=FALSO;
                        num_palancas (screen, sprites, phantomas);
                    }
                }
            }

            // 3. Con las energas

            for (i=0;i<25;i++) {
                if (energias[i].n == pantalla) {
                    if (x>=(energias[i].x<<4)-15 && x<=(energias[i].x<<4)+15 && y==(energias[i].y<<4) && energias[i].on) {
                        if (config.audio)
                            FSOUND_PlaySound (FSOUND_FREE, s_energia);

                        energias[i].on=FALSO;
                        if (phantomas.energia<=230)
                            phantomas.energia+=25;
                        else
                            phantomas.energia=255;
                        marcador(phantomas.energia,vacio,lleno);
                    }
                }
            }

            // 4. Con los tiles malos

            if ((mapa[pantalla].tiles[yy][xx].status & 2 ) == 2) {
                if (config.audio) {
                    FSOUND_StopSound (channel_enemigo);
                    channel_enemigo = FSOUND_PlaySound (FSOUND_FREE, s_enemigo);
                }

                phantomas.energia--;
                marcador(phantomas.energia,vacio,lleno);
            }
            // Comprobaciones:

            if (phantomas.energia<=0) {
                terminado=CIERTO;
                finalizar=CIERTO;
                exito=GAMEOVER;
            }

            //textprintf(screen,font,0,0,makecol(255,255,255),"X: %i, Y: %i, fx:%i, fy:%i, PALANCAS: %i/25",x,y,cabecera.fin_x<<4,cabecera.fin_y+1<<4,phantomas.n_palancas);

            if (phantomas.n_palancas==25 && xp==cabecera.pfi_x && yp==cabecera.pfi_y \
                    && y==((cabecera.fin_y+1)<<4) && x==(cabecera.fin_x<<4)) {
                // EOG!
                exito=CORRECTO;
                terminado=CIERTO;
                finalizar=CIERTO;
            }
            
            if (key[KEY_F] && key[KEY_I] && key[KEY_N]) {
				// debug cheat!
                exito=CORRECTO;
                terminado=CIERTO;
                finalizar=CIERTO;
			}

            // Blitter:
            blitter(p_juego,negra,aux);

            if (show_message > 0 && ok_saving != 0) {
                switch (ok_saving) {
                case 1:
                    imprime_texto(screen,(SCREEN_W>>1)-112,127,"SNAPSHOT SAVED",letras);
                    break;
                case 2:
                    imprime_texto(screen,(SCREEN_W>>1)-120,127,"SNAPSHOT FAILED",letras);
                    break;
                }
                show_message--;
                if (show_message<=0) {
                    ok_saving=0;
                    show_message=0;
                }
            }

            if (key[KEY_LCONTROL] && key[KEY_ALT] && key[KEY_P] && !ok_saving) {
                blit(screen,captura,0,0,0,0,SCREEN_W,SCREEN_H);
                if (save_pcx("snapshot.pcx",captura,pal)) {
                    ok_saving=2;
                } else {
                    ok_saving=1;
                }
                show_message=60;
            }
            
            if (key[KEY_ALT] && key[KEY_ENTER]) {
				config.windowed = !config.windowed;
				if (config.windowed) {
					set_color_depth(16);
		            if ( (set_gfx_mode(GFX_AUTODETECT_WINDOWED,640,480,0,0)) != 0) {
		                set_color_depth(32);
		                if ( (set_gfx_mode(GFX_AUTODETECT_WINDOWED,640,480,0,0)) != 0) {
		                    set_color_depth(24);
		                    set_gfx_mode(GFX_AUTODETECT_WINDOWED,640,480,0,0);
		                }
		            }
				} else {
					set_color_depth(16);
		            if ( (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN,640,480,0,0)) != 0) {
		                set_color_depth(32);
		                if ( (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN,640,480,0,0)) != 0) {
		                    set_color_depth(24);
		                    set_gfx_mode(GFX_AUTODETECT_FULLSCREEN,640,480,0,0);
		                }
		            }
				}	
				blit (background_restorer, screen, 0,0,0,0, 640,480);
				marcador(phantomas.energia,vacio,lleno);
				num_palancas (screen, sprites, phantomas);
			}
			
			if (key[KEY_M]) {
				// Generamos un mapazo!
				generate_map (phantomas, enemigos, plat, mapa, palancas, energias, pantalla, tiles, sprites, fondos, p_juego, cabecera);
			}

            // Temporizacin:
            while (contador_60Hz<2);
            contador_60Hz=0;

        }

        // Lucirnagas

        if (dt == 2) {
            for (i = 0; i < MAX_LUCIERNAGA; i ++) {
                luciernagas[i].x = (rand() % 240) << 8;
                luciernagas[i].y = (rand() % 144) << 8;
                luciernagas[i].mx = ((rand() % 3) - 1) * 16;
                luciernagas[i].my = ((rand() % 3) - 1) * 16;
                luciernagas[i].ax = (rand() % 8) - 4;
                luciernagas[i].ay = (rand() % 8) - 4;
                luciernagas[i].count = 0;
                luciernagas[i].nextcount = 40 + (rand() % 40);
            }
        }

        if (dt==6) {
            n_mvl=rand()%(MAX_MVL-4)+5;
            for (i=0;i<n_mvl;i++) {
                mvl[i].x=((rand()%272)-32)<<8;
                mvl[i].y=((rand()%176)-32)<<8;
                mvl[i].mx=(rand()%512)-256;
                mvl[i].my=(rand()%512)-256;
            }
        }

    }

    if (config.audio) {
        if (dt==22) {
            FSOUND_StopSound (channel_ciudad);

            for (i=0;i<3;i++) {
                FSOUND_Sample_Free (samples_ciudad[i]);
            }
        }

        FSOUND_Sample_Free (s_salto);
        FSOUND_Sample_Free (s_energia);
        FSOUND_Sample_Free (s_palanca);
        FSOUND_Sample_Free (s_caer);
        FSOUND_Sample_Free (s_enemigo);
        FSOUND_Sample_Free (s_suelo);

        if (dt == 41)
            FSOUND_Sample_Free (s_bomb);

        FMUSIC_StopSong (musica);
        FMUSIC_FreeSong (musica);
    }

    if (exito == CORRECTO) {
        // Plays WIN jingle
        // Shows WIN text

		if (!strcmp(nombre, "pachin.upr")) {
		    musica = FMUSIC_LoadSong ("sfx/menu.xm");
		    FMUSIC_SetMasterVolume (musica, config.v_musica);
			FMUSIC_PlaySong (musica);
			
			final (letras, negra, aux);
	
			FMUSIC_StopSong (musica);
	        FMUSIC_FreeSong (musica);
	        
	        exito = FIN;
		}
		
    } else if (phantomas.energia <= 0) {
        // Plays GAME OVER jingle
        // Shows GAME OVER text
        pcx = load_pcx ("gfx/gameover.pcx", nye);
        
        if (config.audio) {
			s_info = FSOUND_Sample_Load (FSOUND_FREE,"sfx/gameover.wav",FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
			FSOUND_PlaySound (FSOUND_FREE, s_info);
    	}

		contador_60Hz = 0;
		i = contador_60Hz;
		phantomas.etoy_muelto = 1;
		while (!key[KEY_ENTER] && !key[KEY_LCONTROL] && !key[KEY_SPACE] && contador_60Hz < 477) {
			if (contador_60Hz - i > 3) {
				i = contador_60Hz;
				if (phantomas.y > 0)
					phantomas.y -= 256;	
				blitter(p_juego,negra,aux);				
	            render(phantomas,enemigos,plat,mapa,palancas,energias,pantalla,\
                   tiles,sprites,fondos,p_juego,cabecera);
			}
		}
		
		contador_60Hz = 477;
		while (!key[KEY_ENTER] && !key[KEY_LCONTROL] && !key[KEY_SPACE] && contador_60Hz < 780) {
			if (contador_60Hz < 599) 
				blit (pcx, p_juego, 0 + rand()%3 -1, 0 + rand()%3 -1, 0, 0, 240, 144);
			else
				blit (pcx, p_juego, 0, 0, 0, 0, 240, 144);
			blitter(p_juego,negra,aux);
		}

		if (config.audio) {
			FSOUND_Sample_Free (s_info);
		}
    }


    for (i=0;i<240;i++) {
        destroy_bitmap(tiles[i]);
        destroy_bitmap(sprites[i]);
    }

    for (i=0;i<5;i++)
        destroy_bitmap(fondos[i]);

	for (i = 0; i < 3; i ++)
		destroy_bitmap (snow [i]);
		
	destroy_bitmap(snow_pcx);
    destroy_bitmap(p_juego);
    destroy_bitmap(negra);
    destroy_bitmap(aux);
    destroy_bitmap(pcx);
    destroy_bitmap(vacio);
    destroy_bitmap(lleno);
    destroy_bitmap(blending);
    destroy_bitmap(captura);
    destroy_bitmap(pizarra);
    destroy_bitmap(dark_overlay);
    destroy_bitmap(fancy_overlay);
    destroy_bitmap(halo);
    destroy_bitmap(halo_rojo);
    destroy_bitmap(halo_amarillo);
    destroy_bitmap(war_overlay);
    destroy_bitmap(buffer_auxiliar);
    destroy_bitmap(buffer_auxiliar_2);
    destroy_bitmap(vaho);
    destroy_bitmap(polvo);
    destroy_bitmap(anti_halo);

    destroy_bitmap(background_restorer);

    for (i=0;i<240;i++)
        destroy_bitmap(letras[i]);

    // En verda esto es por no ser un guarro asqueroso que come mocos:

    remove_display_switch_callback (restorer);

    // Y ya nos vamo, hijo, ya nos vamo, no me sea pesato.

    return(exito);
}

