/**********************************************************************************
   Wopr2K's first "serious" Finished? Game -- PHANTOMAS 3 -- a retrogaming sequel
 **********************************************************************************/

// 11 de Junio de 2005 - Compilo para MinGW32 y le damos la puntilla para acabar YA!

//#define ALLEGRO_STATICLINK

#include <stdio.h>
#include <string.h>

#include <allegro.h>
#include <jpgalleg.h>
#include <fmod.h>
#include "motor.h"
#include "defs.h"
#include "menu.h"
#include "temporizadores.h"
#include "error.h"
#include "closebuttonhandler.h"

void intro() {
	// Deprecated
}

void loga (char *message) {
	FILE *flog;
	
	flog = fopen ("init.log", "a");
	if (flog) {
		fprintf(flog, "%s", message);
		fflush (flog);
		fclose (flog);	
	}	
}

int main(int argc, char *argv[]) {
    BITMAP *pcx;
    FSOUND_SAMPLE *samp;
    int channel;
    int i,j;
    FILE *pf,*log;
    LOGICO login=CIERTO,audio_tmp;
    PALETTE pal;
    BITMAP *aux;
    int resultado;
    char message[256];
    int salir=0;

    allegro_init();
    LOCK_FUNCTION (close_button_handler);
    close_button_pressed = FALSE;
    
    set_display_switch_mode (SWITCH_BACKGROUND);
    
    install_timer();
    instala_temporizador_60Hz();

    if ( !FSOUND_Init(44100, 48, 0) ) {
        ph_error(ERROR_AL_INICIALIZAR_SONIDO);
        config.audio=FALSO;

		sprintf (message, "Error: %s => Audio Desactivado.\n",ph_error_string );
        loga (message);
    }


	install_keyboard();
       
    loga ("Reservando voces.\n");
        
    config.audio=CIERTO;


    /* Esto es de JGMOD - Ya no es necesario, FMOD es ms facil de usar :)
    if(install_mod(32)<0)
    {
    	ph_error(ERROR_AL_INICIALIZAR_SONIDO);
    	config.audio=FALSO;
    	remove_sound();
    	
    	if(login)
    		fprintf(log,"\nError: %s => Audio Desactivado.",ph_error_string);}
    */

    loga("Intentando leer configuracin.\n");

    pf=fopen("Phantomas.cfg","rb");

    if (pf!=NULL) {
        audio_tmp=config.audio;
        fread(&config,sizeof(CONFIGURACIONES),1,pf);
        config.audio=audio_tmp;
        fclose(pf);
        loga ("Configuracin leda.\n");

    } else {
        allegro_message("\nCreating default config file!");
        ph_error(ERROR_AL_ABRIR_CONFIGURACION);
        sprintf(message, "Error: %s => Configuracin por defecto.\n", ph_error_string );
        loga (message);

        config.resolucion=ALTA;
        config.volcado=SCANLINES;
        config.v_musica=128;
        config.v_digital=128;
        config.idioma=INGLES;
        config.windowed = 1;

        pf=fopen("Phantomas.cfg","wb");
        fwrite(&config,sizeof(CONFIGURACIONES),1,pf);
        fclose(pf);
    }

    loga("Leyendo parmetros de entrada.\n");

    if (argc>1) {
        if (strcmp(argv[1], "windowed")!=0)
            config.windowed = 0;
        else
            config.windowed = 1;
    }
    
    loga("Cambiando modo grfico.\n");

    if (config.windowed == 0) {
        if (config.resolucion==ALTA) {
            set_color_depth(16);
            if ( (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN,640,480,0,0)) != 0) {
                set_color_depth(32);
                if ( (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN,640,480,0,0)) != 0) {
                    set_color_depth(24);
                    set_gfx_mode(GFX_AUTODETECT_FULLSCREEN,640,480,0,0);
                }
            }
        } else {
            set_color_depth(16);
            if ( (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN,320,200,0,0)) != 0) {
                set_color_depth(32);
                if ( (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN,320,200,0,0)) != 0) {
                    set_color_depth(24);
                    set_gfx_mode(GFX_AUTODETECT_FULLSCREEN,320,200,0,0);
                }
            }
        }
    } else {
        if (config.resolucion==ALTA) {
            set_color_depth(16);
            if ( (set_gfx_mode(GFX_AUTODETECT_WINDOWED,640,480,0,0)) != 0) {
                set_color_depth(32);
                if ( (set_gfx_mode(GFX_AUTODETECT_WINDOWED,640,480,0,0)) != 0) {
                    set_color_depth(24);
                    set_gfx_mode(GFX_AUTODETECT_WINDOWED,640,480,0,0);
                }
            }
        } else {
            set_color_depth(16);
            if ( (set_gfx_mode(GFX_AUTODETECT_WINDOWED,320,200,0,0)) != 0) {
                set_color_depth(32);
                if ( (set_gfx_mode(GFX_AUTODETECT_WINDOWED,320,200,0,0)) != 0) {
                    set_color_depth(24);
                    set_gfx_mode(GFX_AUTODETECT_WINDOWED,320,200,0,0);
                }
            }
        }
    }

    set_color_conversion(COLORCONV_TOTAL);
	set_trans_blender(0,0,0,64);

    loga("Inicializando jpgalleg.\n");

	jpgalleg_init();

	//    intro(); //daintro();		// Wow! Intro logic GRR!

	aux = create_bitmap (640,480);
    samp=FSOUND_Sample_Load(FSOUND_FREE, "sfx/jingle.wav",FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);

    pcx=load_bitmap("gfx/logo_cezgs.pcx",pal);
	contador_60Hz = 0;    
	i = 0;
    channel = FSOUND_PlaySound (FSOUND_FREE, samp);

    j = 0;
	while (j < 256) {
		clear (aux);
		fblend_trans (pcx, aux, 0, 0, j);
		blit (aux, screen, 0,0,0,0, 650, 479);
		
		j += 4;
		
		while (contador_60Hz == i);
		i = contador_60Hz;
		
		if (keypressed()) {
			FSOUND_StopSound (channel);
            salir=1;
		}
	}

	clear_keybuf();
	j = 252;   
    
    while (contador_60Hz < 452 && !salir) {
		if (contador_60Hz > 388) {
			clear (aux);
			fblend_trans (pcx, aux, 0, 0, j);
			blit (aux, screen, 0,0,0,0, 650, 479);
			j -= 4;	
			while (contador_60Hz == i);
				i = contador_60Hz;
		}
		
        if (keypressed()) {
			FSOUND_StopSound (channel);
            salir=1;
		}
    }
    
    destroy_bitmap (pcx);
    
    if (!salir) {

	    pcx=load_bitmap("gfx/logo_wopr2k.pcx",pal);
	    j = 0;
		i = contador_60Hz;

		while (j < 256) {
			clear (aux);
			fblend_trans (pcx, aux, 0, 0, j);
			blit (aux, screen, 0,0,0,0, 650, 479);
			
			j += 4;
			
			while (contador_60Hz == i);
			i = contador_60Hz;
			
			if (keypressed()) {
				FSOUND_StopSound (channel);
	            salir=1;
			}
		}

		
	    clear_keybuf();
	    j = 252;
	    
	    while (contador_60Hz < 853 && !salir) {
			/*
			if (contador_60Hz > 789) {
				clear (aux);
				fblend_trans (pcx, aux, 0, 0, j);
				blit (aux, screen, 0,0,0,0, 650, 479);
				j -= 4;	
				while (contador_60Hz == i);
					i = contador_60Hz;
			}
			*/

			if (keypressed()) {
				FSOUND_StopSound (channel);
	            salir=1;
			}
	    }
	
	    destroy_bitmap (pcx);
	}
	
	destroy_bitmap (aux);

	// EOI	
	
    i=999;
    
    loga("Entrando el menu.\n");


    while (i!=-1) {
        i=menu();
        
        sprintf(message, "El menu devolvio %d.\n", i);
        loga (message);

        if (i>0) {
            if (i==9)
                i = 1;

            resultado = CORRECTO;
            while (resultado == CORRECTO) {
                switch (i) {
                case 1:
                    resultado = juego ("cueva.upr", 1);
                    break;
                case 2:
                    resultado = juego ("jill.upr", 1);
                    break;
                case 3:
                    resultado = juego ("ciudad.upr", 1);
                    break;
                case 4:
                    resultado = juego ("castle.upr", 1);
                    break;
                case 5:
                    resultado = juego ("salem.upr", 1);
                    break;
                case 6:
                    resultado = juego ("ekynox.upr", 1);
                    break;
                case 7:
                    resultado = juego ("war.upr", 1);
                    break;
                case 8:
                    resultado = juego ("pachin.upr", 1);
                    break;
                case 9:
                    // Final del juego
                    break;
                }

                i ++;
            }
        }
    }
    
	loga("Saliendo del men.\n");

fin:

    // while (key[KEY_ESC]);

    /* Esto es lo que pona las pantallas finales en la demo:

    if(config.resolucion==ALTA)
    	demo_screen=create_bitmap(640,481);
    else
    	demo_screen=create_bitmap(320,201);

    if(config.resolucion==ALTA)
       	demo_screen=load_jpg("gfx/enddemo_1.jpg",pal);
    else
       	demo_screen=load_jpg("gfx/enddemo_1_baja.jpg",pal);

    efectos(demo_screen);
    hline(screen,0,SCREEN_H-1,SCREEN_W-1,0);

    while(!key[KEY_SPACE] && !key[KEY_ENTER] && !key[KEY_ESC]);

    destroy_bitmap(demo_screen);

    clear_keybuf();

    if(config.resolucion==ALTA)
       	demo_screen=load_jpg("gfx/enddemo_2.jpg",pal);
    else
       	demo_screen=load_jpg("gfx/enddemo_2_baja.jpg",pal);

    efectos(demo_screen);
    hline(screen,0,SCREEN_H-1,SCREEN_W-1,0);

    while(!keypressed());

    destroy_bitmap(demo_screen);
    */

    FSOUND_Sample_Free (samp);

    loga ("Borro buffer de teclado.\n");

    clear_keybuf();

    loga ("Fade out.\n");

    binary_fade_out();
    
    loga ("Desinstalo el driver del teclado.\n");

    remove_keyboard();

    loga ("Desinstalo el timer.\n");

    remove_timer();
    
    loga ("allegro_exit ().\n");

    allegro_exit();

    // return(0);
}
END_OF_MAIN();
